<?php
/**
* This function calculates the cost of a conference registration for a given registration number and a praticular conference.
*
* $regid - The unique reqistration number for the registration to the conference.
* $conference - The conference to calculate the cost for the given registration number.
* $formname - The registration form used to create the registration.
* Returns the calculated sum.
*/

//NOTE: This function may at a later stage be moved to basic.php

function calculateRegistrationCost($regid, $conference, $formname = "Default"){
	$sum = 0;
	
	//Get base cost for conference
	$querystring="SELECT price FROM conferences WHERE confname='".sanitizeInput($conference)."' ; ";
	$result=mysql_query($querystring);
	if (!$result) err("SQL Error: ".mysql_error(),"Error when fetching conference base cost information from database.");
	if(mysql_num_rows($result) != 1) err("Conference not found","Sorry");
	$confData = mysql_fetch_assoc($result);
	$sum += $confData['price'];
	
	//Get registration information
	$querystring="SELECT * FROM conf_".sanitizeInput($conference)." WHERE regno='".sanitizeInput($regid)."';";
	$result=mysql_query($querystring);
	if (!$result) err("SQL Error: ".mysql_error(),"Error when fetching registration information from database.");
	if(mysql_num_rows($result) != 1) err("Registration not found","Sorry"); 
	$regData = mysql_fetch_assoc($result);
	//$regData = array_map('html_entity_decode', $regData);
	/*echo "<p> Conference registration data:<br />";
	print_r($regData);
	echo "</p>";*/
  
	/*echo "<p>cost+additionalcost ".$regData['cost']+$regData['additionalCost']."</p>";  //DEBUG CODE - May safely be removed	*/
	//Gather data from forms so sums can be calculated
	$querystring = "SELECT * FROM fieldsNew WHERE conferenceId='".sanitizeInput($conference)."' AND formId='".sanitizeInput($formname)."' ;"; //THE TABLE MAY GET A NEW NAME LATER - MAKE SURE THIS LINE IS UPDATED ACCORDINGLY
	$result = mysql_query($querystring);
	if (!$result) err("SQL Error: ".mysql_error(),"Error when fetching form data from database.");
	while ($row = mysql_fetch_assoc($result)) {
		/*echo "<p> fieldsdata:<br />";
		print_r($row);
		echo "</p>";*/
	
			/*
			fieldtype: 
			1 - Heading 
			2 - Text input 
			3 - Text box 
			4 - Dropdown 
			5 - Placeholder 
			6 - Radio button 
			7 - Checkbox 
			8 - Computation box 
			9 - HR 
			10 - Footnote 
			11 - Image 
			*/
			
		//Check field type and add value to sum if applicable - This part is the one that needs to be recoded to fit whatever tables is used in the database
		if($row['fieldtype'] == 7) { //CHECKBOX
			if($regData[$row['fieldname']] == "YES"){
				$sum+=$row['cost']; 
				//echo "<p>CHECKBOX - YES - $sum</p>"; //DEBUG CODE - May safely be removed	
			} else {
				//echo "<p>CHECKBOX_NO</p>"; //DEBUG CODE	
			} 
		} else if($row['fieldtype'] == 6 ){ //RADIO_BUTTON
			if($regData[$row['groupName']] != NULL){
				if($regData[$row['groupName']] == $row['fieldname']){
					$sum += $row['cost'];
					//echo "<p>RADIO_BUTTON - $sum</p>";
				} else {
					//echo "<p>RADIO_BUTTON_NOPE</p>"; //DEBUG CODE
				} 
			} else {
				 //echo "<p>RADIO_BUTTON_NULL</p>";  //DEBUG CODE
			} 
		} else if($row['fieldtype'] == 4 ){ //SELECT_OPTION_BOX dropdown
			if($regData[$row['groupName']] == $row['fieldname']){
				$sum += $row['cost'];
				//echo "<p>SELECT_OPTION_BOX - $sum</p>";
			} else {
				//echo "<p>SELECT_OPTION_BOX - NOPE</p>"; //DEBUG CODE
			} 	
		} else {
			//echo "<p>Unhandled fieldtype</p>"; //DEBUG CODE
		}
	}

	//If the sum is less then zero we have a serious problem 
	if($sum<0) err("Negative sum.","Error");
	
	return $sum;
}
?>
