
		/*--------------------------------------------------------------------------------
			 AJAX Queue
		----------------------------------------------------------------------------------*/		

		var AJAXQueue = new Array;
		var AJAXServiceRunning=false;

		var httpAjax = false;

		/*--------------------------------------------------------------------------------
				Updatediv
				
				The external function wrapper that is called by any application using the
				AJAX API.
								
		----------------------------------------------------------------------------------*/
		
		function Updatediv(ajaxurl,fieldid,fieldtype,fieldfunc,formname,cardname) {
				
				var paramstr='fieldid='+encodeURIComponent(fieldid);
				if(fieldtype!="") paramstr+=fieldtype;
				paramstr+="&fieldfunc="+encodeURIComponent(fieldfunc);
				paramstr+="&cardname="+encodeURIComponent(cardname);
				paramstr+="&formname="+encodeURIComponent(formname);
				AjaxService(ajaxurl,paramstr);
		}
				
		/*--------------------------------------------------------------------------------
				AjaxService
				
				This is the only interface to the AJAX wrapper. This makes the ajax service 
				browser agnostic and provides a single interface for all of the services.
				
				Each service uses a different url and a different parameter layout.
								
		----------------------------------------------------------------------------------*/

		function AjaxService(servicename,serviceparam,divid){
				
				AJAXQueue.push(servicename);
				AJAXQueue.push(serviceparam);

				if(!AJAXServiceRunning){
						AJAXServiceRunning=true;
						var Aparam=AJAXQueue.pop();
						var Aservice=AJAXQueue.pop();
						AjaxServiceExec(Aservice,Aparam);
				}				
		}

		/*--------------------------------------------------------------------------------
				AjaxService
				
				This is the only interface to the AJAX wrapper. This makes the ajax service 
				browser agnostic and provides a single interface for all of the services.
				
				Each service uses a different url and a different parameter layout.
								
		----------------------------------------------------------------------------------*/

		function AjaxServiceExec(servicename,serviceparam){

			// Parameters are set, initiate AJAX engine
		  if (window.XMLHttpRequest) {
		  	httpAjax = new XMLHttpRequest();
		    if (httpAjax.overrideMimeType) {
		    	httpAjax.overrideMimeType('text/xml');
		    }
		  }else if(window.ActiveXObject){
				try{
					httpAjax = new ActiveXObject("Msxml2.XMLHTTP");
						}catch(e){
							try{
								httpAjax = new ActiveXObject("Microsoft.XMLHTTP");
			        }catch(e){
								alert("Couldnt build an AJAX instance.");
			          return false;
							}
						}
				}
				
				// Send request to Server and initiate callback.
				
		    try{
					httpAjax.onreadystatechange = getPage;
		    }catch(e){
					alert("onreadystatechange didnt go well!");
					return false;
				}try{
					httpAjax.open('POST', servicename, true);
				  httpAjax.setRequestHeader("Content-Type", "application/x-www-form-urlencoded;");
		    }catch(e){
					alert("Couldnt open url.");
		      return false;
		    }try{
						httpAjax.send(serviceparam);				
		    }catch(e){
					alert("Couldnt send request.");
					return false;
				}
		   
			 return true;

		}

		/*--------------------------------------------------------------------------------
				getPage

				This is the AJAX callback function. It detects the invoking service and handles
				the reply from each service accordingly.				
								
		----------------------------------------------------------------------------------*/

	function getPage() {
					
		if(httpAjax.readyState == 4){

				str=httpAjax.responseText;
		 	
				document.getElementById('Contentdiv').innerHTML = str;
				
				if(AJAXQueue.length>0){
						var Aparam=AJAXQueue.pop();
						var Aservice=AJAXQueue.pop();
						AjaxServiceExec(Aservice,Aparam);
				}else{
						AJAXServiceRunning=false;				
				}
				
				return true;				
		}else{
	  		// If any other ready state than prepared, do nothing!
	  }
	}

		/*--------------------------------------------------------------------------------
				savefield

				Not exactly an AJAX function but saves a specified field using the AJAX interface				
								
		----------------------------------------------------------------------------------*/

	function SaveField(fieldno,originalfieldtype,formname,cardname) {

		var fieldtext;

		var param="";
		
		if (cardname==undefined)
		{
		
				if(originalfieldtype==1){
						// Field is a Box Start Field i.e. only has name, type, text, align and color
						fieldname=document.getElementById('fieldname').value;
						fieldtype=document.getElementById('fieldtype').value;
						fieldtext=document.getElementById('fieldtext').value;
						fieldalign=document.getElementById('fieldalign').value;
						fieldcolor=document.getElementById('fieldcolor').value;
		
						param='&fieldname='+encodeURIComponent(fieldname);
						param+="&fieldtype="+encodeURIComponent(fieldtype);
						param+='&fieldtext='+encodeURIComponent(fieldtext);
						param+="&fieldalign="+encodeURIComponent(fieldalign);
						param+="&fieldcolor="+encodeURIComponent(fieldcolor);
				}else if(originalfieldtype==2){
						// Field is a Box End Field i.e. only has name, type 
						fieldname=document.getElementById('fieldname').value;
						fieldtype=document.getElementById('fieldtype').value;
		
						param='&fieldname='+encodeURIComponent(fieldname);
						param+="&fieldtype="+encodeURIComponent(fieldtype);			
				}else if(originalfieldtype==3){
						// Field is a Table Start Field i.e. only has name, type 
						fieldname=document.getElementById('fieldname').value;
						fieldtype=document.getElementById('fieldtype').value;
		
						param='&fieldname='+encodeURIComponent(fieldname);
						param+="&fieldtype="+encodeURIComponent(fieldtype);			
				}else if(originalfieldtype==4){
						// Field is a Table End Field i.e. only has name, type 
						fieldname=document.getElementById('fieldname').value;
						fieldtype=document.getElementById('fieldtype').value;
		
						param='&fieldname='+encodeURIComponent(fieldname);
						param+="&fieldtype="+encodeURIComponent(fieldtype);			
				}else if(originalfieldtype==5){
						// Field is a Row Start Field i.e. only has name, type 
						fieldname=document.getElementById('fieldname').value;
						fieldtype=document.getElementById('fieldtype').value;
		
						param='&fieldname='+encodeURIComponent(fieldname);
						param+="&fieldtype="+encodeURIComponent(fieldtype);			
				}else if(originalfieldtype==6){
						// Field is a Row End Field i.e. only has name, type 
						fieldname=document.getElementById('fieldname').value;
						fieldtype=document.getElementById('fieldtype').value;
		
						param='&fieldname='+encodeURIComponent(fieldname);
						param+="&fieldtype="+encodeURIComponent(fieldtype);			
				}else if(originalfieldtype==7){
						// Field is a Text Input Field i.e. has name, type text alignment spans width size mandatory and default
						fieldname=document.getElementById('fieldname').value;
						fieldtype=document.getElementById('fieldtype').value;
						fieldtext=document.getElementById('fieldtext').value;
						fieldalign=document.getElementById('fieldalign').value;
						fieldspan=document.getElementById('fieldspan').value;
						fieldrowspan=document.getElementById('fieldrowspan').value;
						fieldwidth=document.getElementById('fieldwidth').value;
						fieldsize=document.getElementById('fieldsize').value;
						fieldmandatory=document.getElementById('fieldmandatory').value;
						fielddef=document.getElementById('fielddef').value;
		
						param='&fieldname='+encodeURIComponent(fieldname);
						param+="&fieldtype="+encodeURIComponent(fieldtype);
						param+='&fieldtext='+encodeURIComponent(fieldtext);
						param+="&fieldalign="+encodeURIComponent(fieldalign);
						param+="&fieldspan="+encodeURIComponent(fieldspan);
						param+="&fieldrowspan="+encodeURIComponent(fieldrowspan);
						param+="&fieldwidth="+encodeURIComponent(fieldwidth);
						param+="&fieldsize="+encodeURIComponent(fieldsize);
						param+="&fieldmandatory="+encodeURIComponent(fieldmandatory);
						param+="&fielddef="+encodeURIComponent(fielddef);
				}else if(originalfieldtype==8){
						// Field is a Select Option Box Field i.e. only has name, type 
						fieldname=document.getElementById('fieldname').value;
						fieldtype=document.getElementById('fieldtype').value;
						fieldtext=document.getElementById('fieldtext').value;
						fieldalign=document.getElementById('fieldalign').value;
						fieldspan=document.getElementById('fieldspan').value;
						fieldrowspan=document.getElementById('fieldrowspan').value;
						fieldwidth=document.getElementById('fieldwidth').value;
						fieldsize=document.getElementById('fieldsize').value;
						fieldverify=document.getElementById('fieldverify').value;
						fieldref=document.getElementById('fieldref').value;
		
						param='&fieldname='+encodeURIComponent(fieldname);
						param+="&fieldtype="+encodeURIComponent(fieldtype);
						param+='&fieldtext='+encodeURIComponent(fieldtext);
						param+="&fieldalign="+encodeURIComponent(fieldalign);
						param+="&fieldspan="+encodeURIComponent(fieldspan);
						param+="&fieldrowspan="+encodeURIComponent(fieldrowspan);
						param+="&fieldwidth="+encodeURIComponent(fieldwidth);
						param+="&fieldsize="+encodeURIComponent(fieldsize);
						param+="&fieldverify="+encodeURIComponent(fieldverify);
						param+="&fieldref="+encodeURIComponent(fieldref);
				}else if(originalfieldtype==9){
						// Field is a Placeholder/Spacer etc. Field i.e. has name, type, text aligment, spans and width
						fieldname=document.getElementById('fieldname').value;
						fieldtype=document.getElementById('fieldtype').value;
						fieldtext=document.getElementById('fieldtext').value;
						fieldalign=document.getElementById('fieldalign').value;
						fieldspan=document.getElementById('fieldspan').value;
						fieldrowspan=document.getElementById('fieldrowspan').value;
						fieldwidth=document.getElementById('fieldwidth').value;
		
						param='&fieldname='+encodeURIComponent(fieldname);
						param+="&fieldtype="+encodeURIComponent(fieldtype);
						param+='&fieldtext='+encodeURIComponent(fieldtext);
						param+="&fieldalign="+encodeURIComponent(fieldalign);
						param+="&fieldspan="+encodeURIComponent(fieldspan);
						param+="&fieldrowspan="+encodeURIComponent(fieldrowspan);
						param+="&fieldwidth="+encodeURIComponent(fieldwidth);
				}else if(originalfieldtype==10){
						// Field is a Radio Button Field i.e. has name, type 
						fieldname=document.getElementById('fieldname').value;
						fieldtype=document.getElementById('fieldtype').value;
						fieldtext=document.getElementById('fieldtext').value;
						fieldalign=document.getElementById('fieldalign').value;
						fieldspan=document.getElementById('fieldspan').value;
						fieldrowspan=document.getElementById('fieldrowspan').value;
						fieldwidth=document.getElementById('fieldwidth').value;
						fieldmandatory=document.getElementById('fieldmandatory').value;
						fieldverify=document.getElementById('fieldverify').value;
						fieldref=document.getElementById('fieldref').value;
		
						param='&fieldname='+encodeURIComponent(fieldname);
						param+="&fieldtype="+encodeURIComponent(fieldtype);
						param+='&fieldtext='+encodeURIComponent(fieldtext);
						param+="&fieldalign="+encodeURIComponent(fieldalign);
						param+="&fieldspan="+encodeURIComponent(fieldspan);
						param+="&fieldrowspan="+encodeURIComponent(fieldrowspan);
						param+="&fieldwidth="+encodeURIComponent(fieldwidth);
						param+="&fieldmandatory="+encodeURIComponent(fieldmandatory);
						param+="&fieldverify="+encodeURIComponent(fieldverify);
						param+="&fieldref="+encodeURIComponent(fieldref);
				}else if(originalfieldtype==11){
						// Field is a Computation Display Field i.e. has name, type 
						fieldname=document.getElementById('fieldname').value;
						fieldtype=document.getElementById('fieldtype').value;
						fieldtext=document.getElementById('fieldtext').value;
						fieldalign=document.getElementById('fieldalign').value;
						fieldspan=document.getElementById('fieldspan').value;
						fieldrowspan=document.getElementById('fieldrowspan').value;
						fieldwidth=document.getElementById('fieldwidth').value;
						fieldverify=document.getElementById('fieldverify').value;
		
						param='&fieldname='+encodeURIComponent(fieldname);
						param+="&fieldtype="+encodeURIComponent(fieldtype);
						param+='&fieldtext='+encodeURIComponent(fieldtext);
						param+="&fieldalign="+encodeURIComponent(fieldalign);
						param+="&fieldspan="+encodeURIComponent(fieldspan);
						param+="&fieldrowspan="+encodeURIComponent(fieldrowspan);
						param+="&fieldwidth="+encodeURIComponent(fieldwidth);
						param+="&fieldverify="+encodeURIComponent(fieldverify);
				}else if(originalfieldtype==12){
						// Field is a Check Box Field i.e. has name, type 
						fieldname=document.getElementById('fieldname').value;
						fieldtype=document.getElementById('fieldtype').value;
						fieldtext=document.getElementById('fieldtext').value;
						fieldalign=document.getElementById('fieldalign').value;
						fieldspan=document.getElementById('fieldspan').value;
						fieldrowspan=document.getElementById('fieldrowspan').value;
						fieldwidth=document.getElementById('fieldwidth').value;
						fieldverify=document.getElementById('fieldverify').value;
						fieldref=document.getElementById('fieldref').value;
		
						param='&fieldname='+encodeURIComponent(fieldname);
						param+="&fieldtype="+encodeURIComponent(fieldtype);
						param+='&fieldtext='+encodeURIComponent(fieldtext);
						param+="&fieldalign="+encodeURIComponent(fieldalign);
						param+="&fieldspan="+encodeURIComponent(fieldspan);
						param+="&fieldrowspan="+encodeURIComponent(fieldrowspan);
						param+="&fieldwidth="+encodeURIComponent(fieldwidth);
						param+="&fieldverify="+encodeURIComponent(fieldverify);
						param+="&fieldref="+encodeURIComponent(fieldref);
				}else if(originalfieldtype==13){
						// Field is a Line
						fieldname=document.getElementById('fieldname').value;
						fieldtype=document.getElementById('fieldtype').value;
		
						param='&fieldname='+encodeURIComponent(fieldname);
						param+="&fieldtype="+encodeURIComponent(fieldtype);
				}else if(originalfieldtype==14){
						// Field is a Footnote
						fieldname=document.getElementById('fieldname').value;
						fieldtype=document.getElementById('fieldtype').value;
						fieldtext=document.getElementById('fieldtext').value;
						fieldalign=document.getElementById('fieldalign').value;
		
						param='&fieldname='+encodeURIComponent(fieldname);
						param+='&fieldtype='+encodeURIComponent(fieldtype);
						param+='&fieldtext='+encodeURIComponent(fieldtext);
						param+='&fieldalign='+encodeURIComponent(fieldalign);
		
				}else{
				}

				if(param!="")	Updatediv("tab_manageformservice.php",fieldno,param,"update",formname,cardname);

		}else{
				
				if(originalfieldtype==1){
						// Card Item is a block start element
						typ=document.getElementById('type').value;
						align=document.getElementById('fieldalign').value;
						color=document.getElementById('color').value;
						size=document.getElementById('size').value;
						
						param='&type='+encodeURIComponent(typ);
						param+='&align='+encodeURIComponent(align);
						param+='&color='+encodeURIComponent(color);
						param+='&size='+encodeURIComponent(size);
						
				}else if(originalfieldtype==2){
						// Card Item is a block end element
						typ=document.getElementById('type').value;
						param='&type='+encodeURIComponent(typ);
				}else if(originalfieldtype==3){
						// Card Item is a field element
						typ=document.getElementById('type').value;
						paramo=document.getElementById('param').value;
						font=document.getElementById('font').value;
						color=document.getElementById('color').value;
						size=document.getElementById('size').value;
						breaking=document.getElementById('breaking').value;
						
						param='&type='+encodeURIComponent(typ);
						param+='&param='+encodeURIComponent(paramo);
						param+='&font='+encodeURIComponent(font);
						param+='&color='+encodeURIComponent(color);
						param+='&size='+encodeURIComponent(size);
						param+='&breaking='+encodeURIComponent(breaking);
				}else if(originalfieldtype==4){
						// Card Item is an Image element
						typ=document.getElementById('type').value;
						paramo=document.getElementById('param').value;
						param='&type='+encodeURIComponent(typ);						
						param+='&param='+encodeURIComponent(paramo);
				}else if(originalfieldtype==5){
						// Card Item is a Text Element
						typ=document.getElementById('type').value;
						paramo=document.getElementById('param').value;
						font=document.getElementById('font').value;
						color=document.getElementById('color').value;
						size=document.getElementById('size').value;
						breaking=document.getElementById('breaking').value;
						
						param='&type='+encodeURIComponent(typ);
						param+='&param='+encodeURIComponent(paramo);
						param+='&font='+encodeURIComponent(font);
						param+='&color='+encodeURIComponent(color);
						param+='&size='+encodeURIComponent(size);
						param+='&breaking='+encodeURIComponent(breaking);
				}else if(originalfieldtype==6){
						// Card Item is a Line
						typ=document.getElementById('type').value;
						param='&type='+encodeURIComponent(typ);
				}else if(originalfieldtype==7){
						// Card Item is a NewLine
						typ=document.getElementById('type').value;
						param='&type='+encodeURIComponent(typ);
				}else if(originalfieldtype==8){
						// Card Item is a FormText
						typ=document.getElementById('type').value;
						paramo=document.getElementById('param').value;
						font=document.getElementById('font').value;
						color=document.getElementById('color').value;
						size=document.getElementById('size').value;
						breaking=document.getElementById('breaking').value;
						
						param='&type='+encodeURIComponent(typ);
						param+='&param='+encodeURIComponent(paramo);
						param+='&font='+encodeURIComponent(font);
						param+='&color='+encodeURIComponent(color);
						param+='&size='+encodeURIComponent(size);
						param+='&breaking='+encodeURIComponent(breaking);
				}else if(originalfieldtype==9){
						// Card Item is a Payment Link
						typ=document.getElementById('type').value;
						param='&type='+encodeURIComponent(typ);
				}else{
						alert("Unknown Card Type: !"+originalfieldtype);
						param="";
				}
								
				if(param!="")	Updatediv("tab_managecardlayoutservice.php",fieldno,param,"update",formname,cardname);
								

		}
								
	}
