<?php
Header("content-type: application/x-javascript");

//

if(isset($_GET["tabname"]) && $_GET["tabname"] == 'ManageForms' && isset($_GET["conferencefilter"])) :
	$confname = $_GET["conferencefilter"];
	$formname = "Default"; // TODO: Make sure this is set dynamically and correctly

?>

if(typeof String.prototype.trim !== 'function') {
  String.prototype.trim = function() {
    return this.replace(/^\s+|\s+$/g, ''); 
  }
} // Make sure trim() works in IE8

var radioGroups;

function makeDraggable() {
		$( "#userform" ).sortable({ handle: '.handle',
								  axis: 'y', containment: 'document'});
		$( "#userform li ul" ).sortable({connectWith: '#userform li ul', containment: 'document', opacity: 0.6
										//, placeholder: 'ui-state-highlight'
										});
		$( "#controlpanel #fields ul" ).sortable({connectWith: '#userform li ul', containment: 'document'
												 //, placeholder: 'ui-state-highlight'
												 });
				
		//$( "#userform" ).disableSelection();	
}

function availableWidth(row) {
	var width = row.width();
	var children = row.children();
	
	width -= $(children[0]).outerWidth();
	width -= $(children[1]).outerWidth();
	return width;
	for (child in children) {
		width -= $(child).outerWidth();
	}
	
	return width;
}

function populateFieldsList() {
	
	var fields = 	'<li class="field-heading"><img src="icons/h1.png" /><span>Heading</span></li>' +
					'<li class="field-textinput"><img src="icons/textfield.png" /><span>Text Input</span></li>' +
					'<li class="field-textbox"><img src="icons/textfield.png" /><span>Text Box</span></li>' +
					'<li class="field-dropdown"><img src="icons/dropdown.png" /><span>Dropdown</span></li>' + 
					'<li class="field-placeholder"><img src="icons/placeholder.png" /><span>Placeholder</span></li>' +
					'<li class="field-radio"><img src="icons/radio.png" /><span>Radio Button</span></li>' + 
					'<li class="field-checkbox"><img src="icons/checkbox.png" /><span>Checkbox</span></li>' +
					'<li class="field-computationbox"><img src="icons/computationbox.png" /><span>Computation Box</span></li>' +
					'<li class="field-hr"><img src="icons/hr.png" /><span>Horizontal Ruler</span></li>' +
					'<li class="field-footnote"><img src="icons/footnote.png" /><span>Footnote</span></li>'
					// + '<li class="field-image"><img src="icons/image.png" /><span>Image</span></li>';
	
	$("#controlpanel #fields ul").html(fields);
	//$("#fields ul").disableSelection();
}

function showFieldProperties(field, forceOpen) {
	
	if (field != undefined) {
		
		/* if not already open and should be forced to open */
		if (forceOpen && !$('#controlpanel #sections h3').first().hasClass('ui-state-active')) {
			$("#controlpanel #sections #section1" ).accordion('activate', 0);
		}
		
		/* REMOVE FOCUS FROM THE PREVIOUSLY SELECTED FIELD AND MOVE IT TO THE NEW FIELD */
		removeFieldFocus();			
		field.addClass('field-focused');
		
		var heading = "";
		
		//Clears fieldproperties so that new elements easily can be appended.
		$("#fieldproperties").html('<h3 id="fieldPropertiesHeading"></h3>');
		
		$("#fieldproperties").append('<button name="" id="deletefield">Delete field</button><br />');
		$("#deletefield").button().click(function(){ 
			field.remove(); 
			$("#fieldproperties").html('<span>Field removed. Select a field to view its properties</span>'); 
		});
		
		if (field.hasClass('field-heading')){
			/** HEADING **/
			heading = 'Heading';
			
			/* Heading font size */
			controller_slider('Font size', $('h1', field).first().css('font-size').substr(0, 2), 18, 72, function(event, ui){ 
					$('h1', field).first().css('font-size', ui.value);
				});
			
			/* Heading text */
			controller_textfield('Text', $('h1', field).first().text().trim(), function(text) {
					if (text.length == 0) text = '&nbsp;';
					
					field.children().first().html(text);
				});
			
		}
		else if (field.hasClass('field-textinput')) {
			/** TEXTINPUT **/
			heading = 'Text Input';
			
			// Field Name
			controller_name($('input', field));			
			
			// Label //
			controller_textfield('Label', field.text().trim(), function(text) {
					if (text.length == 0) text = '&nbsp;';
					
					$('span', field).html(text);
				});
				
			// Size
			controller_textfield('Size', $('input', field).first().attr('size'), function(text) {
					if (text.length == 0) text = '20';
					
					$('input', field).first().attr('size', text);
				});
			
			// Alignment
			var orgAlign = $('input', field).attr('data-align') == undefined ? 'left' : $('input', field).attr('data-align');
			controller_textfield('Alignment', orgAlign, function(text) {
					$('input', field).attr('data-align', text);
				});
				
			// Default value //
			controller_textfield('Default', $('input', field).val().trim(), function(text) {
					$('input', field).val(text);
				});
				
			
			// Default value alignment //
			$("#fieldproperties").append('<input type="checkbox" id="alignCheck" /><label for="alignCheck">Alignment</label>');
			$("#alignCheck").button();
			
			$("#alignCheck + label").click(function() {
					
					if ($(this).attr('aria-pressed') == 'true') {
						$('input', field).css('text-align', 'right');
					} else {
						$('input', field).css('text-align', 'left');
					}
				} );
			
		}
		else if (field.hasClass('field-textbox')) {
			/** TEXTBOX **/
			heading = 'Textbox';
			
			//Textbox content
			controller_textfield('Text', field.text().trim(), function(text) {
					if (text.length == 0) text = '&nbsp;';
					
					$('p', field).html(text);
				});
			
		}
		else if (field.hasClass('field-dropdown')) {
			/**  DROPDOWN  **/	
			heading = 'Dropdown';
			
			// Field Name
			controller_name($('select', field));
			
			// Label
			
			controller_textfield('Label', $("span", field).text(), function(text) {
					if (text.length == 0) text = '&nbsp;';
					
					$('span', field).html(text);
				});
			
			// EDIT OPTIONS //	
			controller_optionList('Options', $("select", field).html(), 5, true, 'Default', true, {
				onChange : function (options) {
						$("select", field).html(options);
					}				
			});
			
		}
		else if (field.hasClass('field-placeholder')) {
			/** PLACEHOLDER **/
			heading = 'Placeholder';
			
			// WIDTH SLIDER
			controller_slider('Width', $('div', field).width(), 5, 500, function(event, ui){ 
					$('div', field).width(ui.value);
				});
			
			// HEIGHT SLIDER
			controller_slider('Height', $('div', field).height(), 35, 300, function(event, ui){ 
					$('div', field).height(ui.value);
				});
			
		}
		else if (field.hasClass('field-radio')) {
			/** RADIO GROUP **/
			heading = 'Radio Button';
			
			// Field Name
			controller_name($('input', field));
			
			// Label //
			
			controller_textfield('Label', $("span", field).text(), function(text) {
					if (text.length == 0) text = '&nbsp;';
					
					$('span', field).html(text);
				});
				
			// Price //
			$("#fieldproperties").append("<label class='textfieldLabel' for='optionCost'>Price </label>");

			currentCost = $("input", field).attr('data-cost');
			if (currentCost == undefined) currentCost = 0;
			
			var optionCost  = "<input id='optionCost' type='text' value='" + currentCost + "' />";
			$("#fieldproperties").append(optionCost);
			$("#optionCost").bind('keyup change', function() {
					var cost = $("#optionCost").val();
					
					$('input', field).attr('data-cost', cost);
				} );
			
			// Radio group selector //
			
			var groupNamesString = '';
			
			if (radioGroups == undefined) {
				radioGroups = new Array();
				
				$('#userform input[type="radio"]').each(function(index) {
						
						var groupName = $(this).attr('name');
						
						if (groupName.length > 0 && radioGroups.indexOf(groupName) == -1) {
							radioGroups.push(groupName);
						}
					});
			}
			
			var currentGroupName = $('input', field).attr('name');
			$(radioGroups).each(function (index) {
					var selected = (currentGroupName == this);
					groupNamesString += '<option ' + (selected ? 'selected="selected"' : '') + '>' + this + '</option>';
				});
			
			controller_optionList('Group', groupNamesString, 5, false, 'Default', false, {
				onOptionSelected : function (option) {
					var groupName = $(option).text();
					$('input', field).attr('name', groupName);
					$('input', field).attr('name', groupName);
					//$('#userform input[type="radio"][name="' + groupName + '"]').addClass('field-focused');
				},
				onOptionRemoved : function (option) {
						var groupName = $(option).text();
						radioGroups.splice(radioGroups.indexOf(groupName), 1);
				},
				onOptionAdded : function (option) {
						radioGroups.push($(option).text());
				},
				onOptionValueChange : function (index, newName) {
						var oldName = radioGroups[index];
						radioGroups[index] = newName;
						
						$('#userform input[type="radio"][name="' + oldName + '"]').attr('name', newName);
						
				}
				}
			);
			
		}
		else if (field.hasClass('field-checkbox')) {
			
			/** CHECKBOX **/
			heading = 'Checkbox';
			
			// Field Name
			controller_name($('input', field));
            
            // Label
            controller_textfield('Label', $("span", field).text(), function(text) {
					if (text.length == 0) text = '&nbsp;';
					
					$('span', field).html(text);
				});
			
			// Cost
			controller_cost($('input', field));
			
		}
		else if (field.hasClass('field-computationbox')) {
			/** COMPUTATION BOX **/
			heading = 'Computation Box';
			
		}
		else if (field.hasClass('field-hr')) {
			/** HORIZONTAL RULER **/
			heading = 'Horizontal Ruler';
			
		}
		else if (field.hasClass('field-footnote')) {
			
			/** FOOT NOTE **/
			heading = 'Footnote';
			
			controller_textfield('Label', $('span', field).first().text().trim(), function(text) {
					if (text.length == 0) text = '&nbsp;';
					$('span', field).html(text);
				});
		}
		else if (field.hasClass('field-image')) {
			/** IMAGE **/
			heading = 'Image';
			
			// WIDTH SLIDER
			controller_slider('Width', $('img', field).width(), 5, 500, function(event, ui){ 
					$('img', field).width(ui.value);
				});
			
			// HEIGHT SLIDER
			controller_slider('Height', $('img', field).height(), 35, 300, function(event, ui){ 
					$('img', field).height(ui.value);
				});
		}
		
		$("#fieldproperties #fieldPropertiesHeading").text('Properties for: ' + heading);
	}
}

function removeFieldFocus() {
	$('.field-focused', '#userform').first().removeClass('field-focused');
}

function generateField(field) {

	// TODO: Add default values for data-name, data-cost etc
	var fieldClass = field.attr('class');
	
	html = '';
	
	if (fieldClass == 'field-heading') {
		field.insertBefore(field.closest("#userform>li")); //INSERTS THE HEADING AS A ROW
		html = "<h1>A Heading</h1>"+rowControlsHTML; //Adds the heading content and the row controls
		
	} else if (fieldClass == 'field-textinput') {
		html = '<label><span>Label</span> <input type="text" readonly="readonly" /></label>';
		
	} else if (fieldClass == 'field-textbox') {
		html = '<p>A textbox</p>';
		
	} else if (fieldClass == 'field-dropdown') {
		html = '<label><span>A dropdown</span> <select></select></label>';
		
	} else if (fieldClass == 'field-placeholder') {
		html = '<div></div>';
		
	} else if (fieldClass == 'field-radio') {
		html = '<label><span>A radio button</span> <input type="radio" /></label>';
		
	} else if (fieldClass == 'field-checkbox') {
		html = '<label><span>A check box</span> <input type="checkbox" /></label>';
		
	} else if (fieldClass == 'field-computationbox') {
		html = '<span class="costdisplayer">0</span>';
		
	} else if (fieldClass == 'field-hr') {
		field.insertAfter(field.closest("#userform>li"));
		html = "<hr />" + rowControlsHTML;
		
	} else if (fieldClass == 'field-footnote') {
		field.insertAfter(field.closest("#userform>li"));
		html = "<span>Note</span>" + rowControlsHTML;
		
	} else if (fieldClass == 'field-image') {
		html = '<img src="icons/th_skull.gif" />';
		
	}
	return html;
}

var rowControlsHTML =  "<div class='row-controls'><div class='handle'><img src='./icons/move_form.png' alt='[move]' /></div><div class='insertNewRow'><img src='./icons/add_form.png'alt='[add]' /></div><div class='deleteRow'><img src='./icons/delete_form.png' alt='[move]' /></div></div>";
function newRow(context){
	if(context==undefined) {
		$("#editform #newrow").click();
		return;
	}
	var newRowHTML = "<li class='ui-state-default'> <ul></ul>" + rowControlsHTML + "</li>";
	
	if ($(context.currentTarget).attr('id')=='newrow') { //If called from the add new row button
		$(newRowHTML).appendTo('#userform');
	} else { //If called from a row.
		$(newRowHTML).insertAfter($(context.currentTarget).closest('li'));
	}
	makeDraggable();
}

function formEditorReady() {

	populateFieldsList();
	makeDraggable();

	
	/* BUTTONS */
	$("button", "#controlpanel").button();
	
	/*  CONTROL PANEL TABS */
	$( "#controlpanel #sections #section1" ).accordion({
		collapsible: true, autoHeight: false
	});
	
	$( "#controlpanel #sections #section2" ).accordion({
		collapsible: true, autoHeight: false
	});
	
	/* NEW ROW */
	$('#editform').delegate('#newrow', 'click', newRow);
	
	/* PREVIEW FUNCTIONALITY */
	$('#previewform').click(function() {
			$('input, select', '#userform').removeAttr('disabled');
			$.post("generate.php", { data: escape($("#editform").html()), action: 'preview' }, function(data) {
					$('#formContainer').html(unescape(data));
					tb_show('Preview', '#TB_inline?height=600&width=960&inlineId=previewContainer'); //REMINDER: TITLE[=PREVIEW] SHOULD CONTAIN CONFERENCE NAME[FORMNAME]
				});
			
			$('input, select', '#userform').attr('disabled', 'disabled');
		});
	
	/* EXTERNAL PREVIEW FUNCTIONALITY */
	$('#externalpreviewBtn').click(function() {
			$('input, select', '#userform').removeAttr('disabled');
			$.post("saveform.php", {
						formname : <?php echo "'$formname'"; ?>,
						confname : <?php echo "'$confname'"; ?>,
						action	 : 'save',
						data     : escape($("#editform").html())
						}, function(success) {
							$('#externalPreview').submit();
						});	
			$('input, select', '#userform').attr('disabled', 'disabled');
		});
	
	/* SAVE FUNCTIONALITY */
	$('#saveform').click(function() {
			$('input, select', '#userform').removeAttr('disabled');
			$.post("saveform.php", {
									formname : <?php echo "'$formname'"; ?>,
									confname : <?php echo "'$confname'"; ?>,
									action	 : 'save',
									data     : escape($("#editform").html())
									}, function(success) {
										alert(success);
									});	
									
			$('input, select', '#userform').attr('disabled', 'disabled');
		});
		
	/* LOAD FUNCTIONALITY */
	$('#loadform').click(function() {
		$.post("loadform.php", {
								confname : <?php echo "'$confname'"; ?>
								}, function(data) {
									
									entries = data.split('|');
									var len = entries.length;
									var output = "<form><select id='loadSelect' size="+(len+1)+">";
									for(var i = 0; i < len; i++){
										output += "<option>" + entries[i] + "</option>";
									}
									output += "</select><button id='load' type='button'>Load</button></form>";
									$("#formContainer").html(output);
									$("#load").click(function() {
										var choosen = $("#loadSelect").val();
										choosen = choosen.split(" ");
										//might have a name conflict here
										var formname = choosen[0];
										var confname = choosen[1];
										var revision = choosen[2];
										
										$.post("loadform.php", {
											formname : formname,
											confname : confname,
											revision : revision
											}, function(data) {
												$("#editform").html(unescape(data));
												makeDraggable();
												$('input, select', '#userform').attr('disabled', 'disabled');
											});
										tb_remove();
									});
									tb_show('Load a form', '#TB_inline?height=500&width=960&inlineId=previewContainer');
									
								});
	});
	
	/* MANAGE MOVING FROM FIELDS LIST TO FORM */
	$('#controlpanel #fields ul').bind('sortchange', function(event, ui) {
		//$('#userform').append(ui.item); //Was needed when populate fields ran here. Since it stole the dragged element
		
	});	
	$('#controlpanel #fields ul').bind('sortstop', function(event, ui) {
		populateFieldsList();
	});
	
	/* MAKES SURE NEW ELEMENT ISNT DROPPED IN USERFORM AS ROW ELSE GENERATE THE FIELD HTML*/
	$('#controlpanel #fields ul').bind('sortbeforestop', function(event, ui) {
		
		if ($(ui.item).parent().attr('id') == 'userform') {
			ui.item.remove();
		} else if ($(ui.item).closest('div').attr('id') != 'fields') {
			ui.item.html(generateField($(ui.item)));
			$('input, select', ui.item).attr('disabled', 'disabled');
			showFieldProperties(ui.item, false);
		}
	});	
	
	/* ADDS FUNCTIONALITY TO DELETE ROW-BUTTON */
	$('body').delegate('.row-controls .deleteRow', 'click', function() {
		var parentArray = $(this).parentsUntil('#userform');
		if ($('li', parentArray).hasClass('field-focused') || $(parentArray).hasClass('field-focused')) {
			//A FIELD IN THE DELETED ROW HAD FOCUS. CLEAR FIELD PROPERTIES AND SHOW MESSAGE
			$("#fieldproperties").html('<span>Field removed. Select a field to view its properties</span>'); 
		}
		
		$(this).parentsUntil('#userform').remove();
	});
	
	/* ADDS FUNCTIONALITY TO INSERT ROW-BUTTON */
	$('body').delegate('.row-controls .insertNewRow', 'click', newRow);
	
	/* CLICKING ON ELEMENT OPENS THE CORRECT PROPERTY TAB IN THE CONTROL PANEL */		
	$('body').delegate('#userform li ul li, #userform li.field-heading, #userform li.field-footnote', 'mousedown', function() {
		showFieldProperties($(this), true);
	});
	
	/* CLICKING ON ROW REMOVES FIELD FOCUS */
	$('body').delegate('#userform>li:not(li.field-heading)', 'click', function(context) {
		
		if ($(context.target).attr('class')=='ui-sortable') {
			removeFieldFocus();
		}
		
	});

	//IF THE FORM IS EMPTY, I.E. NO REVISION LOADED CREATE A HEADING, THE ADD-ROW BUTTON AND APPEND A NEW ROW
	if (document.getElementById('editform').childNodes.length == 0){
		$('#editform').append("<ul id='userform'><li class='field-heading' ><h1>An example heading</h1>" + rowControlsHTML + "</li></ul><div class='clearfix' /><div><button id='newrow' type='button'>+</button></div>");	
		/* Run .button and newRow once during initiation */
		$("#newrow", "#editform").button();
		newRow();
	}
	
	$('input, select', '#userform').attr('disabled', 'disabled');	
}

$(window).unload(function() {
	
});

$(window).bind('beforeunload', function() {
	var change = false;
	if( change ) {
		// TODO: Do auto-save
		return "nej";
	} else {
		// IF HERE NO CHANGE HAS OCCURED, SO NO RETURN STATEMENT
	}
});

// FUNCTIONS FOR CREATING EDIT CONTROLLERS //

function controller_name(element) {
	
	currentName = $(element).attr('data-name');
	if (!currentName) currentName = '';
	
	controller_textfield('Name (Must be unique)', currentName, 
		function (val) {
			$(element).attr('data-name', val);
		});
}

function controller_cost(element) {
	currentCost = $(element).attr('data-cost');
	if (!currentCost) currentCost = '0';
	
	controller_textfield('Cost (>= 0)', currentCost, 
		function (val) {
			$(element).attr('data-cost', val);
		});
}

function controller_textfield(label, text, changeCallback) { // label placement? 
	/*if (text != undefined) {
		text = '';
	}*/

	var label = '<label for="labelText">' + label + '</label>';
	var input = "<input type='text' value='" + text + "' />";
	$("#fieldproperties").append(label);
	$("#fieldproperties").append(input);
	input = $("#fieldproperties input").last();
	
	if (changeCallback != undefined)
	{
		$(input).keyup(function() {
				var regExp = /<(?!\s*\/?(br|b|i|u)\b)[^>]+>/ig;
    			var cleanstr = this.value.replace(regExp,''); 
				changeCallback(cleanstr);
			});
	}
}

function controller_slider(label, startValue, min, max, callback) {
	$("#fieldproperties").append("<p>" + label + " - <span>" + startValue + "</span></p>");
	var sliderVal = $("#fieldproperties p span").last();
	var slider = "<div></div>";
	$("#fieldproperties").append(slider);
	slider = $("#fieldproperties div").last();
	
	$(slider).slider({
		value : startValue,
		min   : min,
		max   : max,
		slide : function(event, ui) {
					sliderVal.html(ui.value);
					callback(event, ui);
				}
	});
}

function controller_optionList(label, options, size, allowOptionReordering, defaultNewOptionValue, usePriceField, callbacks) { // options = string with <option>-tags, callbacks = object
	
	/*
	
	Callbacks:
	onOptionValueChange(newName)
	
	onOptionMoved(option)
	onOptionAdded(option)
	onOptionRemoved(option)
	onOptionSelected(option)
	onChange() // on any change
	
	*/
	
	if (callbacks == undefined) callbacks = {};

	function changeControlStates() {
		var selectedOption 	= $("#fieldproperties #optionsList option:selected").first();
		if (selectedOption.length == 0) selectedOption = null;
		
		if (selectedOption == null) {
			$("#editOptionField").attr( "disabled", "disabled" ).val("");
			$("#remOption").attr( "disabled", "disabled" ).button( "option", "disabled", true );
			$('#moveOptionUp')	.button('option', 'disabled', true);
			$('#moveOptionDown').button('option', 'disabled', true);
			$("#editOptionValue").attr( "disabled", "disabled" ).val("");
		} else {
			$("#editOptionField").attr( "disabled", "" );
			$("#remOption").attr( "disabled", "" ).button( "option", "disabled", false );
			$('#moveOptionUp')	.button('option', 'disabled', selectedOption.index() == 0);
			$('#moveOptionDown').button('option', 'disabled', selectedOption.index() == document.getElementById("optionsList").length - 1);
			$("#editOptionValue").attr( "disabled", "" );
		}
	}
	
	function onChange() {
		options = $("#fieldproperties #optionsList").html();
		if (callbacks.onChange) callbacks.onChange(options);
	}
	
	$("#fieldproperties").append("<label class='textfieldLabel' for='optionsList'>" + label +  "</label>");
	$("#fieldproperties").append("<select size='" + size + "' id='optionsList'>" + options + "</select>");
	
	if (allowOptionReordering) {
		$("#fieldproperties").append("<button id='moveOptionUp'>&uArr;</button>");
		$("#fieldproperties").append("<button id='moveOptionDown'>&dArr;</button>");
	}
	
	$("#fieldproperties").append("<button id='remOption'>&mdash;</button>");
	$("#fieldproperties").append("<button id='addOption'>+</button>");
	$("#fieldproperties").append("<input type='text' id='editOptionField' />");
	
	if (usePriceField) {
		$("#fieldproperties").append("<label class='textfieldLabel' for='editOptionCost'>Option Price</label>");
		$("#fieldproperties").append("<input type='text' id='editOptionCost' />");
		
		$("#fieldproperties #editOptionCost").bind('keyup keydown change', function () {
			var selectedOption = $("#fieldproperties #optionsList option:selected");
			var cost = $("#fieldproperties #editOptionCost").val();
			
			selectedOption.attr('data-cost', cost);
			
			onChange();
			if (callbacks.onOptionCostChange) callbacks.onOptionCostChange(selectedOption.index, selectedOption.attr('data-cost'));
		});
	}

	$("#moveOptionUp, #moveOptionDown, #addOption, #remOption", "#fieldproperties").button();
	changeControlStates();

	$("#fieldproperties #optionsList").change( function () {
		
		var selectedOption = $("option", this).get(this.selectedIndex);
		var selectList = this;
		
		if (selectedOption == null) {
			return;
		}
		
		$("#fieldproperties #editOptionField").val(selectedOption.text);
		
		$("#fieldproperties #editOptionField").unbind("keyup").focus();
		
		$("#fieldproperties #editOptionField").keyup(function () {
			selectedOption.text = $("#fieldproperties #editOptionField").val();
			
			onChange();
			if (callbacks.onOptionValueChange) callbacks.onOptionValueChange(selectedOption.index, selectedOption.text);
		});
		
		$("#fieldproperties #editOptionCost").val($(selectedOption).attr('data-cost'));
		
		/*$("#fieldproperties #editOptionCost").unbind("keyup");
		
		$("#fieldproperties #editOptionCost").bind('keyup keydown change', function () {
			selectedOption.value = $("#fieldproperties #editOptionCost").val();
			
			onChange();
		});*/
		
		if (callbacks.onOptionSelected) callbacks.onOptionSelected(selectedOption);
		
		changeControlStates();
		
		$("#remOption").unbind("click").click(function() { // remove option
			var thatIndex  = selectedOption.index;
			if (thatIndex == selectList.length - 1) {
				thatIndex--;
			}
			
			$(selectedOption).remove();
			
			selectList.selectedIndex = thatIndex;
			$(selectList).trigger("change");
			
			onChange();
			
			if (callbacks.onOptionRemoved) callbacks.onOptionRemoved(selectedOption);
			
			changeControlStates();
		} );
	} );				

	$("#addOption").click( function() { // add option
		var val = $("#fieldproperties #editOptionField").val();
		if (val.length == 0) {
			val = defaultNewOptionValue;
		}
		
		$("#fieldproperties select#optionsList").append("<option value=''>"+ val +"</option>");
		
		var newOption = $("#fieldproperties #optionsList option:last");
		var newOptionIndex = newOption.index();
		
		document.getElementById("optionsList").selectedIndex = newOptionIndex; //Makes the new option look selected
		$("#fieldproperties #optionsList").trigger("change"); //Makes the new option clicked
		
		onChange();
		
		if (callbacks.onOptionAdded) callbacks.onOptionAdded(newOption);
		
		changeControlStates();
	} );

	if (allowOptionReordering) {
		$("#moveOptionUp").click(function() {
			var selected = $("#fieldproperties #optionsList option:selected");
			var previous = $("#fieldproperties #optionsList option").get(selected.index() - 1);
			
			selected.insertBefore(previous);
			
			onChange();
			
			if (callbacks.onOptionMoved) callbacks.onOptionMoved(selected);
			
			changeControlStates();
		} );

		$("#moveOptionDown").click(function() {
			var selected 	= $("#fieldproperties #optionsList option:selected");
			var next 		= $("#fieldproperties #optionsList option").get(selected.index() + 1);
			
			selected.insertAfter(next);
			
			onChange();
			
			if (callbacks.onOptionMoved) callbacks.onOptionMoved(selected);
			
			changeControlStates();
		} );
	}
}

function controller_filebrowse() { // Browse (for uploading stuff)
	
}

<?PHP elseif(isset($_GET["tabname"]) && $_GET["tabname"] == 'ManageForms'): ?>

function formEditorReady() {
	$('[name = "conferencefilterform"]').submit();
}

<?php else: ?>

function formEditorReady() {}

<?PHP endif; ?>
