if (typeof console == "undefined" || typeof console.log == "undefined") {
	var console = { log: function() {} };
}
$('html').removeClass('no-js');

function moveCostDisplayers() {
	$('table').each(function(index, table) {
/*			var maxTd = getMaxAmountTd(table);
 			$('span.costdisplayer', table).each(function(indx, costdisplayer) {  //THIS IS A WORKING ALGORITHM, BUT WILL NOT FILL OUT EACH TR WITH EMPTY TD'S
					var parentTableCell = costdisplayer.parentNode;
					var parentTableRow = parentTableCell.parentNode;
					parentTableCell.setAttribute("class", "containsCostdisplayer");
					parentTableRow.removeChild(parentTableCell);
					while (parentTableRow.childNodes.length < maxTd-1) {
						var emptyTd = document.createElement("td");
						parentTableRow.appendChild(emptyTd);
					}
					parentTableRow.appendChild(parentTableCell);
				}); */
			$('tr', table).each(function(indx, row) {
					var haveCostdisplayer = false;
					if ($(row).children().children('span.costdisplayer').length > 0) {
						haveCostdisplayer = true;
						$(row).children().children('span.costdisplayer').parent().remove();
					}
					var maxTd = getMaxAmountTd(table);
					while (row.childNodes.length < maxTd-1) {
						var emptyTd = document.createElement("td");
						row.appendChild(emptyTd);
					}
					if (haveCostdisplayer) {
						$(row).append("<td class='containsCostdisplayer'><span class='costdisplayer'>0</span></td>");
					} else {
						var emptyTd = document.createElement("td");
						row.appendChild(emptyTd);						
					}
				});
		});
}

function getMaxAmountTd(table) {
	maxTd = 0;
	$(table).children().children('tr').each(function(indx, elem) {
		if (elem.childNodes.length > maxTd) {
			maxTd = elem.childNodes.length;
		}
	});
	return maxTd;
}

function updateCostDisplayer(element) {
	if (element.nodeName == 'TR') { //Function is called from initiation stage
		var costingElements = $(element).children().children().children('input, select');
		if (   (costingElements.length > 0 )
			&& (costingElements.filter('[data-cost]:checked').length > 0 || costingElements.children('[data-cost]:selected').length > 0 )
			){
				var currentTableRow = element;
		}
	} else if (element.hasAttribute('data-cost') || $(element).children(':selected')[0].hasAttribute('data-cost') ) { //Function is called from element onchange event
		var currentTableRow = element.parentNode.parentNode.parentNode;
	} else {
		return; //Element doesnt have a cost. Dont try to count it. Otherwise script might create unwanted costdisplayer
	}
		
	var costDisplayer = getCostDisplayer(currentTableRow);
	
	currentTableRow = costDisplayer.parentNode.parentNode;
	
	trArray = new Array();
	prevTr = $(currentTableRow).prev('tr');
	trArray.push(currentTableRow);
	
	while (prevTr.length != 0 && $(".costdisplayer", prevTr).length == 0) {
		prevTr = prevTr[0];
		currentTableRow = prevTr;
		trArray.push(currentTableRow);
		prevTr = $(prevTr).prev('tr');
	}
	array = filterCostElements(trArray);
	var sum = 0;
	for (var i=0, len=array.length; i<len; i++) {
		sum += Number(array[i].getAttribute('data-cost'));
	}
	$(costDisplayer).text(sum);
}

function getCostDisplayer(tableRow) {
	//IF NO .COSTDISPLAYER IN CURRENT ROW, TRY IN NEXT. RETURN IT WHEN FOUND
	while($(".costdisplayer", tableRow).length == 0) {
		if (tableRow.nextSibling == undefined) {
			$(tableRow).append("<td><span class='costdisplayer'>0</span></td>");
			moveCostDisplayers();
		} else {
			tableRow = tableRow.nextSibling;
		}
	}
	var costDisplayer = $(".costdisplayer", tableRow)[0];
	return costDisplayer;
}

function filterCostElements(trArray) {
	var elements = $(trArray).children().children().children();
	var optionsArray = $.makeArray(elements.filter('select').children().filter('option:selected'));
	var inputArray = $.makeArray(elements.filter('input:checked'));
	return optionsArray.concat(inputArray);
}

function updateTotalCost(basePrice) {
	$('span.totalSum').fadeOut(100, function() {
			var totalSum = $('span.totalSum').text();
			var textAndCost = totalSum.split(": ");
			var costDisplays = $.makeArray($('span.costdisplayer'));
			var sum = Number(basePrice);
			for (var i = 0, len = costDisplays.length; i < len; i++) {
				sum += Number($(costDisplays[i]).text());
			}
			$('span.totalSum').text(textAndCost[0] + ': ' + sum).fadeIn(200);
		});
	
}

$('document').ready(function() {
	var basePrice = ($('span.totalSum').text()).split(": ");
	basePrice = basePrice[1];
	
	moveCostDisplayers();
	
	$('body form').delegate('input, select', 'change', function() {
			updateCostDisplayer(this);
			updateTotalCost(basePrice);
		});
	$('tr').each( function(index, row) {
			updateCostDisplayer(row);
			updateTotalCost(basePrice);
		});
});