<link rel='stylesheet' href='css/registrations.css' media=''/>
<link rel='stylesheet' href='css/print_registrations.css' media='print'/>
<?php
ini_set('error_reporting', E_ALL);
ini_set('display_errors', 'On');
ini_set('display_startup_errors', 'On');
	/**
	  * Printing all registrations
	  *
	  * Enables the printing of all registered on a conference
	  * Sorting and column selection is made before coming to this script
	  *
	  * PHP version 4, 5
	  *
	  * @author     Denis dervisevic <echuu88@gmail.com>
	  * @license    http://www.gnu.org/copyleft/lesser.html LGPL License 3
	  * @since      File availible since Revision 79
	  */
	  
	include("basic.php");
	include("dbcredentialspath.php");
	include(DB_CREDENTIALS_PATH);
	
	dbConnect();
	
	if(isset($_POST['conferencefilter']) && $_POST['conferencefilter'] != '') {
		echo "<form action='index.php' method='post'>";
		
		
		//echo "<input class='hiddenCheckString' type='hidden' name='checkString' value='' />";
		
		
		$conferencefilter = $_POST['conferencefilter'];
		passon("conferencefilter", $conferencefilter);
		
		if(isset($_POST['filterReg']) && !empty($_POST['filterReg'])) { // The searched terms
			$keywords = $_POST['filterReg'];
			passon("filterReg", $keywords);
			
		}
		if(isset($_POST['filterColumn']) && !empty($_POST['filterColumn'])) { // The filter button after the search
			$filterColumn = $_POST['filterColumn'];
			passon("filterColumn", $filterColumn);
		}
		if(isset($_POST['sortorder'])) {
			$sortorder = $_POST['sortorder'];
			$sortkind = $_POST['sortkind'];
			passon('sortorder', $sortorder);
			passon("sortkind", $sortkind);
		}
		
		if(isset($_POST['suspiciousState']))
			$suspState = $_POST['suspiciousState'];
		else
			$suspState = 0;		
		passon('suspiciousState', $suspState);

		echo "<input type='hidden' name='tabname' value='ViewRegistrations' />";	//Hide variables for back button
		echo "<br/><input type='submit' value='Back'/>";
		echo "</form>";
		echo "<button value='Print' onclick='window.print();return false;'>Print</button>"; //Prints w/ js, other css is called to hide buttons
		echo "<h1><span class='part'>Attendees</span><br/>";
	
		$result = mysql_query("SELECT * FROM conferences WHERE confname='".$conferencefilter."'");
		if (!$result) err("SQL Query Error: ".mysql_error(),"Database Query Error");
		
		while($row = mysql_fetch_assoc($result)) {
			echo $row['longname']."</h1>";
			echo "<p id='confdate'>".substr($row['confdate'], 0, -3)."</p>";
		}
		echo "<p id='printed'>Printed: ".date('Y-m-d H:i:s')."</p>";
		echo "<hr />";
		$querystring = "SELECT ";
		$result = mysql_query("SHOW COLUMNS FROM conf_".$conferencefilter.""); //Gets all columns
		if (!$result) err("SQL Query Error: ".mysql_error(),"Database Query Error");
		
		$fieldsExist = false;
		$filteredColumns = array();
		while($row = mysql_fetch_array($result)) {
			if(isset($_POST[$row[0]])) { //Check if set, to reduce errors
				if($_POST[$row[0]] == '1') { //If the checkbox was checked
					$querystring .= $row[0].", "; //Adds the column name to the SQL query
					$fieldsExist = true;
					$filteredColumns[] = $row[0];
				}
			}
			$allColumns[] = $row[0];
		}
		
		$querystring = substr($querystring, 0, strlen($querystring)-2);
		
		if(!empty($filteredColumns)) {
			if(sizeof($filteredColumns) >= 20) { //If there are 20 columns
				echo "<p id='warning'>Due to the amount of columns you should consider printing in landscape orientation.</p>";
			}
		}
		else {
			$filteredColumns = $allColumns;
		}
		
		if($fieldsExist) { //If there is filtering
			$querystring .= " FROM conf_".$conferencefilter;
			if(isset($filterColumn)) //If a filter column button has been pressed
				$querystring .= searchOneColumn($conferencefilter, $keywords, true, $filterColumn, $suspState);
			else if(isset($keywords)) // If a search has been performed
				$querystring .= genSearchStr($conferencefilter, $keywords, true, $suspState);
		}	
		else {
			$querystring = "SELECT * FROM conf_".$conferencefilter; //No Column filtering hence get all
			if(isset($filterColumn))
				$querystring = searchOneColumn($conferencefilter, $keywords, false, $filterColumn, $suspState);
			else if(isset($keywords))
				$querystring = genSearchStr($conferencefilter, $keywords, false, $suspState);	
		}
		
		if(!(isset($keywords)) && !(isset($filterColumn)) && $suspState != 1) {
				$querystring .= " WHERE state != 5"; 
		}
		
		$querystring = addsortorder($querystring,$sortorder,$sortkind); //Sort accordingly
	
		$result=mysql_query($querystring);
		if (!$result) err("SQL Query Error: ".mysql_error(),"Database Query Error");
		
		$states = array('', 'Unpaid',  'Paid by card', 'Paid by invoice', 'Reminder sent', 'Suspicious');
		echo "<table border='0' cellspacing='0'>";
		echo "<tr>";
		foreach($filteredColumns as $column) {
			echo "<th>".ucwords($column)."</th>";
		}
		echo "</tr>";
		
		while ($row = mysql_fetch_assoc($result)) {
			echo "<tr>";
			foreach ($row as $key => $field) {
				if($key == "state")
					echo "<td>".$states[$field]."</td>\n";
				else
					echo "<td>".htmlspecialchars_decode($field)."</td>\n";
			} 
			echo "</tr>";
		}
		echo "</table>";
	}
	else { //If the conference name is missing, show error
		echo "<h1>Woops, an error occured</h1>";
		echo "<form action='index.php' method='post'>";
		echo "<input type='hidden' name='tabname' value='ViewRegistrations' />";
		echo "<br/><input type='submit' value='Back'/>";
		echo "</form>";
	}
?>
