<?php

	// +----------------------------------------------------------------------+
	// | PernillaSYS.                                                         |
	// +----------------------------------------------------------------------+
	// | This file is subject to the GNU GPL license                          |
	// +----------------------------------------------------------------------+

	header('Content-type: text/html; charset=utf-8');
	
	session_start();

	include("basic.php");
	
	include("dbcredentialspath.php");
	include(DB_CREDENTIALS_PATH);
	dbConnect();	
	
	include("Register_function.php");

	//-----------------------------------------------------------	
	// This is the html file header code
	//-----------------------------------------------------------
	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">';
	echo '<html xmlns="http://www.w3.org/1999/xhtml" class="no-js">';
	echo '<head>';
	echo "<meta http-equiv='content-type' content='application/xhtml+xml; charset=UTF-8' />";
	echo "<link rel='icon' href='Pernilla_Icon_16x16.png' type='image/png' />";
	echo "<link rel='stylesheet' href='css/forms.css' type='text/css' />";
	echo "<script type='text/javascript' src='js/jquery-1.5.2.min.js'></script>";
	echo '<script type="text/javascript" src="js/registerhelp.js" ></script>';
	echo "<title>";
	echo "PernillaSYS - Conference Registration Page";
	echo "</title>";
		include "Analytics/Include.php";
	echo "</head>";
	echo "<body><div id='formContainer'>";
	
	//Get the name of the conference
	if(isset($_GET['conf'])){
		$confname =sanitizeInput($_GET['conf']);
		$formname = 'Default';
	} else {
		err("No conference name supplied.");
	}
	
	//Check if its a preview thats requested
	if(isset($_GET['preview'])){
		$preview=TRUE;
	} else {
		$preview=FALSE;
	}
	
	//Display the form for given conference
	showRegistrationForm($confname, $formname, $preview);
	
	echo "</div></body>\n";
	echo "</html>\n";
?>
