﻿<?php
	include_once("basic.php");
	include("dbcredentialspath.php");
	include(DB_CREDENTIALS_PATH);
	include_once("costFunction.php");
	
	dbConnect();
	
	$_POST = array_map('sanitizeInput', $_POST);
	$_GET = array_map('sanitizeInput', $_GET);
	
	//-----------------------------------------------------------
	// This is the html file header code
	//-----------------------------------------------------------
	
	echo "<html>";
	echo "<head>"; 
	echo "<meta http-equiv='content-type' content='application/xhtml+xml; charset=UTF-8' />";
	echo "<link rel='icon' href='Pernilla_Icon_16x16.png' type='image/png' />";
	echo "<link rel='stylesheet' type='text/css' media='print' href='css/register_confirm_print.css'>";
	echo "<title>";
	echo "Pernilla. Conference Registration & Payment System";
	echo "</title>";
	echo "</head>";
	
	echo "<body>";
	// The algorithm is as follows
	
	// Make the insert from the field data
	// Select inserted data into $row variable
	// Select Data from card into $card variable
	//Build two strings one with the email confirmation and one with the main confirmation
	
	//echo '<pre>';print_r($_POST);echo '</pre>';
	
	if(isset($_POST['confname'])) {
		if(!isset($_POST['formname'])){
			err("No form sent.","Error");
		}
		
		$idcode=getUniqueCode(12);
		
		$columnstring	= "";
		$valuestring	= "";
		
		$columnstring	.= "regno";
		$valuestring	.= "'" . $idcode . "'";

		$columnstring	.= ",state";
		$valuestring	.= ",'1'";
		
		$columnstring	.= ",cost";
		$valuestring	.= ",'0'"; //Will be calculated below

		$columnstring	.= ",additionalcost";
		$valuestring	.= ",'0'";
				
		$result	= mysql_query("SELECT * FROM fieldsNew WHERE conferenceId = '" . $_POST['confname'] . "' AND formId = '" . $_POST['formname'] . "'"); // order by fieldsort;");
		if (!$result) err("SQL Query Error: ".mysql_error(),"Database Query Error");
		
		$dropDowns = array(); // To ensure dropdown options haven't been accounted for already
		while ($row = mysql_fetch_assoc($result)) {
			
			// If checkbox
			if ($row['fieldtype'] == 7) { // TODO: Constants..
				$columnstring	.= ", `" . $row['fieldname']."`";
				if (isset($_POST[str_replace(" ","_",$row['fieldname'])])) {	
					$valuestring .= ", 'YES'";
				} else {
					$valuestring .= ", 'NO'";
				}
			} // If dropdown
			else if ($row['fieldtype'] == 4) { // TODO: Constants..
				if (!isset($dropDowns[$row['groupName']])) {
					$columnstring	.= ", `" . $row['groupName']."`";
					$valuestring .= ", '" . sanitizeInput(trim($_POST[$row['groupName']]), '\'\"') . "'";
					$dropDowns[$row['groupName']] = '';
				}
			} // If radio button
			else if ($row['fieldtype'] == 6) { // TODO: Constants..
				if (!isset($dropDowns[$row['groupName']])) {
					$columnstring	.= ", `" . $row['groupName']."`";
					$valuestring .= ", '" . sanitizeInput(trim($_POST[str_replace(" ","_",$row['groupName'])]), '\'\"') . "'";
					$dropDowns[$row['groupName']] = '';
				} 
			}
			else if (isset($_POST[$row['fieldname']])) {
				$columnstring.= ", `" . $row['fieldname']."`";
				$valuestring .= ", '" . sanitizeInput(trim($_POST[$row['fieldname']],'\'\"')) . "'";
			} else {
				$columnstring	.= ", " . $row['fieldname'];
				$valuestring .= ', ""';
			}
		}			
		$querystring = 'INSERT INTO conf_' . sanitizeInput($_POST['confname']) . '(' . sanitizeInput($columnstring) . ') VALUES (' . $valuestring . ');';
		//echo "<p>".$querystring."</p>";
		$result = mysql_query($querystring);
		if (!$result) err("Error when inserting registration in database. SQL Update Error: ".mysql_error(),"Database Update Error");
		// Now! Get an array containing the form text elements 
		$formtext = array();
		$result = mysql_query("SELECT DISTINCT(fieldname), fieldtext FROM fieldsNew WHERE conferenceId = '" . $_POST['confname'] . "' AND formId = '" . $_POST['formname'] . "' AND TRIM(fieldtext) != ''");
		if (!$result) err("SQL Query Error: " . mysql_error(), "Database Query Error");		
						
		while ($row = mysql_fetch_assoc($result)) {
			$workstring = trim(str_replace("&nbsp;", "", $row['fieldtext']));
			if ($workstring != ""){
				$formtext[$row['fieldname']] = $workstring;
			}										
		}
		
		// First collect the newly created item
		$querystring="SELECT * FROM conf_" . $_POST['confname'] . " WHERE regno='" . $idcode . "'";
		$result = mysql_query($querystring);
		if (!$result) err("Data Retrieval Error: ".mysql_error(),"Database Update Error");
		
		while ($row = mysql_fetch_assoc($result)){
			//echo "<br>ROW:<br><pre>";//print_r($row);//echo"</pre><br>";
			//Calculate cost of registration
			$cost = calculateRegistrationCost($idcode, $_POST['confname'], $_POST['formname']);
			$additionalcost = $row['additionalCost'];
			//Update registration data with cost
			$qs="UPDATE conf_".sanitizeInput($_POST['confname'])." SET cost='".sanitizeInput($cost)."' WHERE regno='".sanitizeInput($idcode)."' ;";
			$r=mysql_query($qs);
			if (!$r) err("Error when updating cost for registration. SQL Update Error: ".mysql_error(),"Database Update Error");
			
			// Process confirmation!
			$innerresult=mysql_query("SELECT * FROM cardlayout WHERE formname='".sanitizeInput($_POST['confname'])."' AND cardname='RegConfirm' AND type IS NOT NULL ORDER BY cardsort");
			if (!$result) err("SQL Query Error: ".mysql_error(),"Database Query Error");		
			
			if(mysql_num_rows($result) != 0){ //No RegCard found
			
				$emailstring="";
				$screenstring="";
		
				// Now iterate over confirmation fields and create the two strings.
				while ($innerrow = mysql_fetch_assoc($innerresult)) {
					/*echo "<br>INNERROW:<pre>";
					print_r($innerrow);
					echo "</pre>";*/
					
					//Example of $innerrow data:
					//Array ( [layoutno] => 129 [cardname] => RegConfirm [formname] => OSS2010REG [cardsort] => 25 [type] => 1 [alignment] => Left [color] => white [font] => Verdana [size] => Small [breaking] => 0 [param] => [cond] => [otherwise] => [clear] => ) 

					//Building inline-styling for card elements
					$innerstyle="<span style='";
					$innerstyle.="color:".$innerrow['color'].";";
					$innerstyle.="font-family:\"".$innerrow['font']."\";";
					$innerstyle.="font-size:".$innerrow['size'].";";
					$innerstyle.="'>";
					$innerSpanEnd="</span>";
					
					if($innerrow['type'] == FIELD){ //Field
						if($innerrow['param']=="Regno") $innerrow['param']="regno"; //Fix to make sure registration numbers are displayed
						if(isset($row[$innerrow['param']])){									
							$emailstring.=$row[$innerrow['param']]." ";
							$screenstring.=$innerstyle.$row[$innerrow['param']].$innerSpanEnd." ";
						}
					}else if($innerrow['type'] == CARD_IMAGE){ //Image
						$screenstring.="<img src='".$innerrow['param']."' />";
					}else if($innerrow['type'] == TEXT){ //Text
						$emailstring.=$innerrow['param']." ";
						$screenstring.=$innerstyle.$innerrow['param'].$innerSpanEnd." ";
					}else if($innerrow['type'] == HORIZONTAL_LINE){ //Horizontal line
						$emailstring.="\n------------------------------------------------------------------------\n";
						$screenstring.="<hr />";
					}else if($innerrow['type'] == LINEBREAK){ //Linebreak
						$emailstring.="\n";
						$screenstring.="<br />";						
					}else if($innerrow['type'] == FORMTEXT){ //Formtext
						if(isset($formtext[$innerrow['param']])){
							$emailstring.=$formtext[$innerrow['param']]." ";
							$screenstring.=$innerstyle.$formtext[$innerrow['param']].$innerSpanEnd." ";
						}
					}else if($innerrow['type'] == PAYLINK){ //Payment link
						//$emailstring.="\nhttp://conferenceregistration.his.se/Payment.php?conf=".$_POST['confname']."&regid=".$row['regno']."\n";
						//$screenstring.="<a href='http://conferenceregistration.his.se/Payment.php?conf=".$_POST['confname']."&regid=".$row['regno']."'>Registration Payment</a>";
						$screenstring.="<a href='Payment.php?conf=".$_POST['confname']."&regid=".$row['regno']."'>Registration Payment</a>";
						$emailstring.="\nhttp://".$_SERVER['HTTP_HOST'].substr($_SERVER['PHP_SELF'], 0, strrpos($_SERVER['PHP_SELF'], "/")+1)."Payment.php?conf=".$_POST['confname']."&regid=".$row['regno']."\n";
					}

				}
			} 
		
			echo "<div style='width:40%;margin: 10px auto; margin-bottom:80px;'>";
			echo("<p style='font-weight:bold;'>Thank you for your registration!</p>");
			//Try to send confirmation e-mail
			if(isset($row['Email'])){ //No E-mail supplied for the registration form
				$to = $row['Email'];
				$subject = "Conference Registration Confirmation";
				$body = $emailstring;
				
				if(mail($to, $subject, $body)){
					echo "<p>A conference registration confirmation message has been sent. Please check your e-mail to make sure you have received your confirmation message. You may also choose to print your registration confirmation below.</p> 
						  <p>Important! Please take note of your registration number, if presented, since this will simplify any future contact with our conference staff. </p>";
					
				}else{
					echo "<p>Due to an internal server error no registration confirmation message has been sent.
							 However your registration has still been received and successfully registered.</p>
						  <p>You may choose to print your registration confirmation below.</p>";
						  
				}
			} 
			echo "<p>Important! Please take note of your registration number, if presented, since this will simplify
							 any future contact with our conference staff. </p>";
			echo "<p>If the information below is incorrect please contact us as soon as possible and we will help you make the necessary changes.</p>";
			$total = $cost + $additionalcost;
			echo "<p>Your registration will cost: <strong>".$total."</strong></p>";
			
			//echo "<a href='Payment.php?conf=".$_POST['confname']."&regid=".$row['regno']."'>Continue to payment</a>";
			echo "<form name='toPayment' action='Payment.php' method='get' >";
			echo "	<input type='hidden' name='conf' value='".$_POST['confname']."' />";
			echo "	<input type='hidden' name='regid' value='".$row['regno']."' />";
			echo "	<input type='submit' value='Continue to payment' />";
			echo "</form>";
			echo "</div>";	
		}
		
		//Gather card styling information
		$querystring = "SELECT * FROM cards WHERE cardname='RegConfirm' AND formname='".sanitizeInput($_POST['confname'])."';";
		$result=mysql_query($querystring);
		if (!$result) err("SQL Query Error: ".mysql_error(),"Database Query Error <br /> Error when retrieving cards data.");	
		if(mysql_num_rows($result) != 0){ //A RegConfirm card is found
			$row = mysql_fetch_assoc($result);
			
			if(isset($row['width'])) {
				$cardwidth=$row['width']."cm";
			} else {
				$cardwidth="100%";
			}
			
			if(isset($row['height'])) {
				$cardheight=$row['height']."cm";
			} else {
				$cardheight="100%";
			}
			
			$backgroundimage=$row['background'];
			if(isset($row['borderkind'])) {
				$cardsstyle = "border-style:".$row['borderkind'].";";
			} else {
				$cardsstyle = "border-style:solid;";
			}
			if(isset($row['borderwidth'])) {
				$cardsstyle.= "border-width:".$row['borderwidth'].";";
			} else {
				$cardsstyle.= "border-width:1px;";
			}
			if(isset($row['bordercolor'])) {
				$cardsstyle .= "border-color:".$row['bordercolor'].";";
			} else {
				$cardsstyle .= "border-color:#000;";
			}
			$cardsstyle .= "width:".$cardwidth.";";
			$cardsstyle .= "height:".$cardheight.";";

			$cardsstyle .= "margin: 0 auto;";
			
			//Display card on screen
			echo "<div style='".$cardsstyle."'>";
			//Background image
			echo "<img style='position:absolute;z-index:0;width:".$cardwidth.";height:".$cardheight.";' src='".$backgroundimage."' />";
			//Card text
			echo "<div style='position:absolute;overflow:hidden;z-index:5;width:".$cardwidth.";height:".$cardheight.";' >".$screenstring."</div>";
			echo "</div>";
		} 
		//Display printing button
		echo "<br /><div style='text-align: center;'><form><input type='button' value=' Print this page ' onclick='window.print();return false;' /></form></div>";
	}else{
		echo "Error! No Conference Was Supplied";
	}
	echo "</body>\n";
	echo "</html>\n";
	
	/*
		// Important fix for NOT adding too many commas for radio groups	
		if(($row['fieldtype']!=RADIO_BUTTON)||($oldradio!=$row['fieldref'])){
			$columnstring=$columnstring.",";
			$valuestring=$valuestring.",";
		}
	*/		

?>
