<?php

	// +----------------------------------------------------------------------+
	// | PernillaSYS.                                                         |
	// +----------------------------------------------------------------------+
	// | This file is subject to the GNU GPL license                          |
	// +----------------------------------------------------------------------+
	session_start();
	
	header('Content-type: text/html; charset=utf-8');
	include("cookiecheck.php"); //- Temporarily disabled.
				
	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">';
	echo '<html xmlns="http://www.w3.org/1999/xhtml">';
	echo '<head>';
	echo "<meta http-equiv='content-type' content='application/xhtml+xml; charset=UTF-8' />";
	echo "<link rel='icon' href='Pernilla_Icon_16x16.png' type='image/png' />";
	echo "<link rel='apple-touch-icon' href='Pernilla_Icon_Full.png'/>"; // Web app icon iOS/Android/BB
	echo "<meta name='apple-mobile-web-app-capable' content='yes' />"; // Full screen on iOS
	echo "<link rel='apple-touch-startup-image' href='css/images/ios_loading.png' />"; //Loading screen
	echo "<title>";
	echo "PernillaSYS - Conference Registration and Payment System";
	echo "</title>";
	echo "<link rel='stylesheet' type='text/css' href='css/datepicker.css'/>";
	echo "<link rel='stylesheet' type='text/css' href='css/tipsy.css' type='text/css' />";
	echo "<link rel='stylesheet' type='text/css' href='js/thickbox/thickbox.css' media='screen'/>";
	echo "<link rel='stylesheet' type='text/css' href='js/multiSelect/style.css'/>";
	echo "<script type='text/javascript' language='javascript' src='floater.js'></script>";
	echo "<script type='text/javascript' language='javascript' src='httpAjax.js'></script>";		
	echo "<script type='text/javascript' language='javascript' src='js/jquery-1.5.2.min.js'></script>";	
	echo "<script type='text/javascript' language='javascript' src='js/jquery-ui.min.js'></script>";
	echo "<script type='text/javascript' language='javascript' src='js/jquery-ui-timepicker-addon.js'></script>";
	echo "<script type='text/javascript' language='javascript' src='js/jquery.tipsy.js'></script>";
	echo "<script type='text/javascript' language='javascript' src='js/ajaxfunction.js'></script>";
	echo "<script type='text/javascript' language='javascript' src='js/jquery.numeric.js'></script>";
	echo "<script type='text/javascript' language='javascript' src='js/currentRevision.js'></script>";
	echo "<script type='text/javascript' language='javascript' src='js/thickbox/thickbox-compressed.js'></script>";
	echo "<script type='text/javascript' language='javascript' src='js/multiSelect/multiSelect.js'></script>";	
	echo "<script type='text/javascript' language='javascript' src='js/html5.js'></script>";
	$query = '';
	if (!isset($_POST['mypassword'])) {
		$query = http_build_query($_POST);
	}
	echo '<script type="text/javascript" language="javascript" src="js/formeditor.js.php?' . $query . '"></script>';
	echo "<script type='text/javascript' language='javascript' src='js/documentReady.js'></script>";
	echo "<!--[if lte IE 6]><script type='text/javascript' language='javascript' src='js/ie6/warning.js'></script><script>window.onload=function(){e('js/ie6/')}</script><![endif]-->";
	
	//Colorpicker
	echo '<link rel="stylesheet" media="screen" type="text/css" href="colorpicker/css/colorpicker.css" />';	
	echo '<script type="text/javascript" language="javascript" src="colorpicker/js/colorpicker.js"></script>';
	echo '<script type="text/javascript" language="javascript" src="js/colorPicker.js"></script>';
	
	//Mainly used in form editor, might create conflicts in datepicker.
	echo '<link href="css/ui-lightness/jquery-ui-1.8.11.custom.css" rel="stylesheet" type="text/css" />';
	
	//Style Sheet. href exempelvis variabel beroende på vilket tema du vill andända.
	echo "<link href='css/stylesheet.css' rel='stylesheet' type='text/css' />";
	
	if(isset($_POST['theme'])){
		echo '<link href="css/'.$_POST['theme'].'.css" rel="stylesheet" type="text/css" />';
	}else if(isset($_COOKIE['theme'])){
		echo '<link href="css/'.$_COOKIE['theme'].'.css" rel="stylesheet" type="text/css" />';		
	}else
		echo '<link href="css/default.css" rel="stylesheet" type="text/css" />';
	
	//CSS for Formeditor and final forms.. should possibly be merged
	echo '<link href="css/formeditor.css" rel="stylesheet" type="text/css" />';
	echo '<link href="css/forms.css" rel="stylesheet" type="text/css" />';
	
	include "Analytics/Include.php";
	echo "<script type=\"text/javascript\" language='javascript' src=\"https://www.google.com/jsapi\"></script>";
	echo "</head>";

	include("basic.php");
	include("conferencestyles.php");
	include("dbcredentialspath.php");
	include(DB_CREDENTIALS_PATH);

	echo "<body>";
	echo "<div id='wrapper'>";	
	
	include("personallogin.php");
	
	if(mysql_num_rows($result) != 0){

		echo "<header>";
			echo '<div style="float: right; text-align: right; font-size: 1.3em; padding: 5px 7px 0 0">Logged in as <strong>' . $myusername . '</strong><br />';
			echo '<form action="index.php" name="theme" method="post">';
			echo '<select id="wierd" name="theme" onchange="document.theme.submit();">';
			
			$styles = array('default', 'simple', 'starcraft', 'callofduty');
			
			for($i = 0; $i < 4; $i++){
				if(isset($_POST['theme'])){
					if($styles[$i] == $_POST['theme']){
						echo '<option selected="selected">'.$styles[$i].'</option>';
					}else{
						echo '<option>'.$styles[$i].'</option>';
					}
				}else{
					if($styles[$i] == $_COOKIE['theme']){
						echo '<option selected="selected">'.$styles[$i].'</option>';
					}else{
						echo '<option>'.$styles[$i].'</option>';
					}						
				}
			}
			if (isset($_POST['tabname'])) {
				$tabname = $_POST['tabname'];
				passon("tabname", $tabname);
			} else {
				passon("tabname", "");
			}
			echo '</select>';
			echo '</form>';
			echo '<a href="logoff.php">Log out</a></div>';
			echo '<div style="clear: both"></div>';
		echo "</header>";
		
		include("savelogin.php");

		echo "<nav><ul id='mainNav'>";
		$userkind = $_SESSION["userkind"];
		//Different tabs depending of user type
		if($userkind==ADMIN || $userkind==ORGANIZER || $userkind==CLIENT){		
			menuheading("About",$tabstyle,"Main",$tabname);
			menuheading("Manage Forms",$tabstyle,"ManageForms",$tabname);
			menuheading("View Registrations",$tabstyle,"ViewRegistrations",$tabname);
		}
		if($userkind==ADMIN){											
			menuheading("View Logs",$tabstyle,"ViewLogs",$tabname);
			menuheading("Manage Users",$tabstyle,"ManageUsers",$tabname);
		}
		if($userkind==ADMIN || $userkind==ORGANIZER ){
			menuheading("Manage Conferences",$tabstyle,"ManageConferences",$tabname);
			menuheading("Manage Cards",$tabstyle,"ManageCards",$tabname);
			menuheading("Manage Card Layout",$tabstyle,"ManageCardLayout",$tabname);
		}
		echo "</ul></nav>";
								
		echo "<div id='content'>";
			include("tab_main.php");
			include("tab_viewregistrations.php");
			include("tab_viewlogs.php");
			include("tab_manageforms.php");
			include("tab_managecards.php");
			include("tab_managecardlayout.php");
			include("tab_manageusers.php");
			include("tab_manageconferences.php");			
		echo "</div>";	
		
		generatetabform("index.php","Main");
		generatetabform("index.php","ViewRegistrations");
		generatetabform("index.php","ViewLogs");
		generatetabform("index.php","ManageUsers");
		generatetabform("index.php","ManageConferences");
		generatetabform("index.php","ManageForms");
		generatetabform("index.php","ManageCards");
		generatetabform("index.php","ManageCardLayout");
	}else{
		echo '<div style="clear: both;"></div>';
		if(isset($_COOKIE['theme'])) { //Cookies are enabled
			loginform("index.php","Login name is staff email","Organizer Login");
			if(isset($_POST['loginFail'])) echo "<h2>Incorrect username and/or password.</h2>";
		}
	}
	echo '<footer>';
		$revData = explode(" ", file_get_contents("./.bzr/branch/last-revision"));
		echo "<span id='rev' style='font-size: 1.2em;'>Revision ".$revData[0]."</span><br/>";
		$revSplit = explode("-", $revData[1]);
		echo $revSplit[0]." - ";
		echo substr($revSplit[1], 0, 4)."-";
		echo substr($revSplit[1], 4, 2)."-";
		echo substr($revSplit[1], 6, 2)." ";
		echo substr($revSplit[1], 8, 2).":";
		echo substr($revSplit[1], 10, 2).":";
		echo substr($revSplit[1], 12, 2)." UTC";
	echo "</footer>";
	
	echo "</div>";
	echo "</body>";
	echo "</html>"
?>
