<?php

	//Connect to database
	//Check the name and assures it doesn't exist.
	//Creates tables
	//Creates users
	/*	***NU FINNS DET DEMO DATA TILL TABELLERNA***
			
			[X]conferences
			[ ]conferenceslog
			[X]options
			[X]fieldtype
			[X]fields
			[ ]fieldslog
			[X]cards
			[ ]cardslog
			[X]cardlayout
			[ ]cardlayoutlog
			[X]cardlayouttypes
			[X]imgurl
			[/]personal - skapas admin med databasen
			[ ]personallog
	*/
	
	//*******************************************************
	//
	//					CONFERENCE TABLES
	//
	//*******************************************************
		
	$conferences = "CREATE TABLE IF NOT EXISTS `conferences` (
  `confname` varchar(64) NOT NULL DEFAULT '',
  `longname` varchar(256) DEFAULT NULL,
  `confdate` datetime DEFAULT NULL,
  `regstart` datetime DEFAULT NULL,
  `regend` datetime DEFAULT NULL,
  `offlineregend` datetime DEFAULT NULL,
  `beforetext` varchar(256) DEFAULT NULL,
  `aftertext` varchar(256) DEFAULT NULL,
  `offlineaftertext` varchar(256) DEFAULT NULL,
  `locked` int(11) DEFAULT NULL,
  `price` int(11) DEFAULT 0,
  PRIMARY KEY (`confname`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

	$conferenceslog ="CREATE TABLE IF NOT EXISTS `conferenceslog` (
  `conflogno` int(11) NOT NULL AUTO_INCREMENT,
  `confname` varchar(64) DEFAULT NULL,
  `longname` varchar(256) DEFAULT NULL,
  `confdate` datetime DEFAULT NULL,
  `regstart` datetime DEFAULT NULL,
  `regend` datetime DEFAULT NULL,
  `offlineregend` datetime DEFAULT NULL,
  `beforetext` varchar(256) DEFAULT NULL,
  `aftertext` varchar(256) DEFAULT NULL,
  `offlineaftertext` varchar(256) DEFAULT NULL,
  `price` int(11) DEFAULT 0,
  `locked` int(11) DEFAULT NULL,
  `posttime` datetime DEFAULT NULL,
  `user` varchar(80) DEFAULT NULL,
  PRIMARY KEY (`conflogno`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=30 ;";
	
	//*******************************************************
	//
	//						CARD TABLES
	//
	//*******************************************************
	
	$cards = "CREATE TABLE IF NOT EXISTS `cards` (
  `cardno` int(11) NOT NULL AUTO_INCREMENT,
  `cardtype` int(11) DEFAULT NULL,
  `cardname` varchar(20) DEFAULT NULL,
  `formname` varchar(20) DEFAULT NULL,
  `background` varchar(64) DEFAULT NULL,
  `width` int(11) DEFAULT NULL,
  `height` int(11) DEFAULT NULL,
  `columncount` int(11) DEFAULT NULL,
  `rowcount` int(11) DEFAULT NULL,
  `borderwidth` int(11) DEFAULT NULL,
  `marginwidth` int(11) DEFAULT NULL,
  `bordercolor` varchar(32) DEFAULT NULL,
  `borderkind` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`cardno`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=24 ;";

	$cardslog ="CREATE TABLE IF NOT EXISTS `cardslog` (
  `logno` int(11) NOT NULL AUTO_INCREMENT,
  `cardno` int(11) DEFAULT NULL,
  `cardtype` int(11) DEFAULT NULL,
  `cardname` varchar(20) DEFAULT NULL,
  `formname` varchar(20) DEFAULT NULL,
  `background` varchar(64) DEFAULT NULL,
  `width` int(11) DEFAULT NULL,
  `height` int(11) DEFAULT NULL,
  `columncount` int(11) DEFAULT NULL,
  `rowcount` int(11) DEFAULT NULL,
  `borderwidth` int(11) DEFAULT NULL,
  `marginwidth` int(11) DEFAULT NULL,
  `bordercolor` varchar(32) DEFAULT NULL,
  `borderkind` varchar(32) DEFAULT NULL,
  `posttime` datetime DEFAULT NULL,
  `user` varchar(80) DEFAULT NULL,
  PRIMARY KEY (`logno`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=79 ;";
	
	$cardlayout = "CREATE TABLE IF NOT EXISTS `cardlayout` (
  `layoutno` int(11) NOT NULL AUTO_INCREMENT,
  `cardname` varchar(20) DEFAULT NULL,
  `formname` varchar(20) DEFAULT NULL,
  `cardsort` int(11) DEFAULT NULL,
  `type` int(11) DEFAULT NULL,
  `alignment` varchar(16) DEFAULT NULL,
  `color` varchar(32) DEFAULT NULL,
  `font` varchar(32) DEFAULT NULL,
  `size` varchar(32) DEFAULT NULL,
  `breaking` int(11) DEFAULT NULL,
  `param` varchar(256) DEFAULT NULL,
  `cond` varchar(64) DEFAULT NULL,
  `otherwise` varchar(64) DEFAULT NULL,
  `clear` varchar(64) DEFAULT NULL,
  PRIMARY KEY (`layoutno`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=383 ;";

	$cardlayoutlog ="CREATE TABLE IF NOT EXISTS `cardlayoutlog` (
  `layoutlogno` int(11) NOT NULL AUTO_INCREMENT,
  `layoutno` int(11) DEFAULT NULL,
  `cardname` varchar(20) DEFAULT NULL,
  `formname` varchar(20) DEFAULT NULL,
  `cardsort` int(11) DEFAULT NULL,
  `type` int(11) DEFAULT NULL,
  `alignment` varchar(16) DEFAULT NULL,
  `color` varchar(32) DEFAULT NULL,
  `font` varchar(32) DEFAULT NULL,
  `size` varchar(32) DEFAULT NULL,
  `breaking` int(11) DEFAULT NULL,
  `param` varchar(256) DEFAULT NULL,
  `cond` varchar(64) DEFAULT NULL,
  `otherwise` varchar(64) DEFAULT NULL,
  `clear` varchar(64) DEFAULT NULL,
  `posttime` datetime DEFAULT NULL,
  `user` varchar(80) DEFAULT NULL,
  PRIMARY KEY (`layoutlogno`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=394 ;";
	
	$cardlayouttypes ="CREATE TABLE IF NOT EXISTS `cardlayouttypes` (
  `fieldtype` int(11) NOT NULL DEFAULT '0',
  `typename` varchar(40) DEFAULT NULL,
  PRIMARY KEY (`fieldtype`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

	//*******************************************************
	//
	//					  FIELDS TABLES
	//
	//*******************************************************
	
	$fieldsNew = "CREATE TABLE IF NOT EXISTS `fieldsNew` (
  `fieldname` varchar(30) NOT NULL,
  `conferenceId` varchar(30) NOT NULL,
  `formId` varchar(30) NOT NULL,
  `fieldtext` varchar(30) NOT NULL DEFAULT '',
  `fieldtype` tinyint(4) NOT NULL COMMENT '1 - Heading\r\n2 - Text input\r\n3 - Text box\r\n4 - Dropdown\r\n5 - Placeholder\r\n6 - Radio button\r\n7 - Checkbox\r\n8 - Computation box\r\n9 - HR\r\n10 - Footnote\r\n11 - Image\r\n\r\nNot all of these (for example heading) should be in this table ',
  `groupName` varchar(30) DEFAULT NULL,
  `cost` float DEFAULT NULL,
  PRIMARY KEY (`fieldname`,`conferenceId`,`formId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";
	
	$fieldslog = "CREATE TABLE IF NOT EXISTS `fieldslog` (
  `logid` int(11) NOT NULL AUTO_INCREMENT,
  `fieldno` int(11) DEFAULT NULL,
  `fieldsort` int(11) DEFAULT NULL,
  `fieldname` varchar(30) DEFAULT NULL,
  `fieldtype` int(11) DEFAULT NULL,
  `fieldtext` varchar(512) DEFAULT NULL,
  `fieldsize` int(11) DEFAULT NULL,
  `fieldspan` int(11) DEFAULT NULL,
  `fieldrowspan` int(11) DEFAULT NULL,
  `fieldwidth` varchar(10) DEFAULT NULL,
  `fieldcolor` varchar(8) DEFAULT NULL,
  `fielddef` varchar(60) DEFAULT NULL,
  `fieldalign` varchar(8) DEFAULT NULL,
  `fieldref` varchar(16) DEFAULT NULL,
  `fieldverify` varchar(256) DEFAULT NULL,
  `formname` varchar(20) DEFAULT NULL,
  `fieldmandatory` int(11) DEFAULT NULL,
  `posttime` datetime DEFAULT NULL,
  `user` varchar(80) DEFAULT NULL,
  PRIMARY KEY (`logid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1284 ;";

	$fieldtypes = "CREATE TABLE IF NOT EXISTS `fieldtypes` (
  `fieldtype` int(11) NOT NULL DEFAULT '0',
  `typename` varchar(40) DEFAULT NULL,
  PRIMARY KEY (`fieldtype`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

	$formlog = "CREATE TABLE IF NOT EXISTS `formlog` (
  `formname` varchar(64) NOT NULL,
  `conferenceId` varchar(64) NOT NULL,
  `revision` int(11) NOT NULL,
  `formHTML` text NOT NULL,
  `date` datetime NOT NULL,
  PRIMARY KEY (`formname`,`conferenceId`,`revision`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

	//*******************************************************
	//
	//					   IMG TABLE
	//
	//*******************************************************
	
	$imgurl = "CREATE TABLE IF NOT EXISTS `imgurl` (
  `imgno` int(11) NOT NULL AUTO_INCREMENT,
  `url` varchar(256) DEFAULT NULL,
  `name` varchar(48) DEFAULT NULL,
  PRIMARY KEY (`imgno`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=22 ;";

	
	

	//*******************************************************
	//
	//					 PERSONAL TABLE
	//
	//*******************************************************
	
	$personal = "CREATE TABLE IF NOT EXISTS `personal` (
  `PID` int(11) NOT NULL AUTO_INCREMENT,
  `firstname` varchar(40) DEFAULT NULL,
  `lastname` varchar(40) DEFAULT NULL,
  `posttime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `persemail` varchar(80) DEFAULT NULL,
  `pw` varchar(25) DEFAULT NULL,
  `kind` int(11) DEFAULT NULL,
  `conferences` varchar(256) DEFAULT NULL,
  `last_ip` varchar(15) DEFAULT NULL,
  PRIMARY KEY (`PID`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=28 ;";

	$personallog = "CREATE TABLE IF NOT EXISTS `personallog` (
  `PLOGID` int(11) NOT NULL AUTO_INCREMENT,
  `PID` int(11) DEFAULT NULL,
  `firstname` varchar(40) DEFAULT NULL,
  `lastname` varchar(40) DEFAULT NULL,
  `posttime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `persemail` varchar(80) DEFAULT NULL,
  `pw` varchar(25) DEFAULT NULL,
  `kind` int(11) DEFAULT NULL,
  `conferences` varchar(256) DEFAULT NULL,
  `logposttime` datetime DEFAULT NULL,
  `user` varchar(80) DEFAULT NULL,
  PRIMARY KEY (`PLOGID`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=48 ;";

	$admin = "INSERT INTO `personal` (`persemail`, `pw`, `kind`) VALUES ('".$adminEmail."', '".$adminPassword ."', 1)";
	
	mysql_query($conferences) or die(mysql_error());
	mysql_query($conferenceslog) or die(mysql_error());
	
	mysql_query($cards) or die(mysql_error());
	mysql_query($cardslog) or die(mysql_error());	
	mysql_query($cardlayout) or die(mysql_error());	
	mysql_query($cardlayoutlog) or die(mysql_error());
	mysql_query($cardlayouttypes) or die(mysql_error());
	
	mysql_query($fieldsNew) or die(mysql_error());
	mysql_query($fieldslog) or die(mysql_error());
	mysql_query($fieldtypes) or die(mysql_error());
	mysql_query("insert into fieldtypes (fieldtype,typename) values ('1','Box Heading Start');") or die(mysql_error()); 
	mysql_query("insert into fieldtypes (fieldtype,typename) values ('2','Box Heading End');") or die(mysql_error()); 
	mysql_query("insert into fieldtypes (fieldtype,typename) values ('3','Table Start');") or die(mysql_error()); 
	mysql_query("insert into fieldtypes (fieldtype,typename) values ('4','Table End');") or die(mysql_error()); 
	mysql_query("insert into fieldtypes (fieldtype,typename) values ('5','Row Start');") or die(mysql_error()); 
	mysql_query("insert into fieldtypes (fieldtype,typename) values ('6','Row End');") or die(mysql_error()); 
	mysql_query("insert into fieldtypes (fieldtype,typename) values ('7','Text Field');") or die(mysql_error()); 
	mysql_query("insert into fieldtypes (fieldtype,typename) values ('8','Select Option Box');") or die(mysql_error()); 
	mysql_query("insert into fieldtypes (fieldtype,typename) values ('9','Placeholder');") or die(mysql_error()); 
	mysql_query("insert into fieldtypes (fieldtype,typename) values ('10','Radio Button');") or die(mysql_error()); 
	mysql_query("insert into fieldtypes (fieldtype,typename) values ('11','Locked Computation Box');") or die(mysql_error()); 
	mysql_query("insert into fieldtypes (fieldtype,typename) values ('12','Checkbox');") or die(mysql_error()); 
	mysql_query("insert into fieldtypes (fieldtype,typename) values ('13','Line');") or die(mysql_error()); 
	mysql_query("insert into fieldtypes (fieldtype,typename) values ('14','Footnote');") or die(mysql_error()); 
	mysql_query("insert into fieldtypes (fieldtype,typename) values ('15','Image');") or die(mysql_error()); 
	mysql_query($formlog) or die(mysql_error());
	
	mysql_query($imgurl) or die(mysql_error());
	mysql_query('insert into imgurl (imgno,url,name) values("1","BackPinko.png","BackPinko.png")') or die(mysql_error());
	mysql_query('insert into imgurl (imgno,url,name) values ("2","Footprint.png","Footprint.png")') or die(mysql_error());
	mysql_query('insert into imgurl (imgno,url,name) values("3","PrintBack.png","PrintBack.png")') or die(mysql_error());
	mysql_query('insert into imgurl (imgno,url,name) values("4","logo.png","logo.png")') or die(mysql_error());
	
	mysql_query($personal) or die(mysql_error());
	mysql_query($personallog) or die(mysql_error());
	mysql_query($admin) or die(mysql_error());
	
?>
