function multiSelectReady() {
	$("#confmultiselect").click(function (){
		// Internet Explorer:
		if (document.all)
		  document.onselectstart =
			function () { return false; };
		
		// Netscape 4:
		if (document.layers) {
		  document.captureEvents(Event.MOUSEDOWN);
		  document.onmousedown =
			function (evt) { return false; };
		}
		
		// Netscape 6:
		document.onmousedown = function () { return false; };
		
		$("#openConf").trigger('click');
	});
		
	var returnVal = "";
	$("#btnSaveList").click(function(){
		returnVal = "";
		$("#selectedList ul li").each(function(index) {
			returnVal += $(this).text()+",";
		});
		returnVal = returnVal.substr(0, returnVal.length-1);
		$("#confmultiselect").val(returnVal);
		tb_remove();
	});
	
	function setSelectedClass(element)
	{
		//Avmarkera alla i motsvarande lista
		var unSelList = "selectedList";
		if($(element).closest("div").attr("id")=="selectedList")
			unSelList = "unselectedList";
			
		$("#"+unSelList).each(function(index){
			$("#"+unSelList+" ul li").removeClass("selected");
		});
		
		//Markera element man tryckt på
		if($(element).hasClass("selected"))
			$(element).removeClass("selected");
		else
			$(element).addClass("selected");
			
	}
	
	$("#unselectedList ul li").click(function(){
		setSelectedClass(this);
	});
	
	$("#selectedList ul li").click(function(){
		setSelectedClass(this);
	});
	
	//Sorterar elementen i listorna efter överföring av element.
	function sortLists(currList){
		var sortArray = new Array();
		
		$("#"+currList+" ul li").each(function(index){
			sortArray.push($(this).text());
			sortArray.sort();
			$(this).remove();
		})
		
		var printList = "";
		while(sortArray.length > 0){
			printList += "<li>"+sortArray.shift()+"</li>";
		}
		$("#"+currList+" ul").html(printList);
	}
		
	//Flyttar alla markerade element
	$("#add").click(function(){
		var counter = 0;
		$("#unselectedList .selected").each(function(index) {
			$("#selectedList ul").html($("#selectedList ul").html()+"<li>"+$(this).text()+"</li>");
			$(this).remove();
			counter++;
		});

		if(counter>0)
		{		
			sortLists("selectedList");
			$("#selectedList ul li").click(function(){
				setSelectedClass(this);
			});
		}
		
	});
	//Flyttar alla markerade element
	$("#remove").click(function(){
		var counter = 0;
		$("#selectedList .selected").each(function(index) {
			$("#unselectedList ul").html($("#unselectedList ul").html()+"<li>"+$(this).text()+"</li>");
			$(this).remove();
			counter++;
		});
		if(counter>0)
		{
			sortLists("unselectedList");
			$("#unselectedList ul li").click(function(){
				setSelectedClass(this);
			});
		}
	});
	
	var mDown = false;
	/*$("#unselectedList ul li").mousedown(function(){
		mDown = true;
		if(mDown)
		{
			$(this).mousemove(function() {
				$("#dragBox").fadeIn(function() {
					//$("#dragBox")
				});
			});
		}
	});*/
	function countSelItem()
	{
		var i = 0;
		$("#unselectedList ul li").each(function(index) {
			if($(this).hasClass("selected"))
				i++;
		});
		return i;
	}
	
	$(this).mousedown(function() {
		mDown = true;
		//$("#dragBox").text("Move "+countSelItem()+" items");
	});
	$(this).mouseup(function() {
		mDown = false;
	});
	$(this).mousemove(function() {
		if(mDown)
		{
			/*$("#dragBox").fadeIn(function() {
						//$("#dragBox")
			});*/
			$("#unselectedList ul li").hover(function() {
				if(mDown)
				{
					$(this).addClass("selected");
				}
			});
			$("#selectedList ul li").hover(function() {
				if(mDown)
				{
					$(this).addClass("selected");
				}
			});
		}else{
			/*$("#dragBox").fadeOut(function() {
						//$("#dragBox")
			});*/
		}
	});
}
