<?php
	require_once('generate.php');
	/**
	 * tab_manageconferences.php handles the creation and management of conferences.
	 *
	 * The file supports:
	 * 	- Creation of new conferences.
	 * 	- Copying information from one conference to another.
	 * 	- Changing current conferences.
	 * 	- Locking / Unlocking conferences.
	 *
	 */
	if($tabname=="ManageConferences" && ($userkind==ADMIN || $userkind==ORGANIZER )){
		$conferenceexists = false; // Variable which indicates if the conferencename already exists or not, variable is used for validation.
	
		function lockConf($confname) {
			// Create registration table for conference
			
			$fieldsQuery = "SELECT * FROM fieldsNew WHERE conferenceId = '$confname' AND formId = 'Default'";
			
			$fieldsResult = mysql_query($fieldsQuery);
			$query = 'CREATE TABLE conf_' . $confname . ' (lineno INTEGER AUTO_INCREMENT, regno VARCHAR(16), ';
			$dropDowns = array();
			while ($field = mysql_fetch_array($fieldsResult)) {
				if ($field['fieldtype'] == 4 || $field['fieldtype'] == 6) {
					// Dropdown or radio button
					if (!isset($dropDowns[$field['groupName']])) {
						$query  .= "`". $field['groupName'] . "` VARCHAR (60), ";
						$dropDowns[$field['groupName']] = '';
					}
				} 
				else $query  .= "`".$field['fieldname']."` VARCHAR (60), ";
			}
			
			$query .= 'cost INTEGER, additionalCost INTEGER, state INTEGER, PRIMARY KEY(lineno)) ENGINE=InnoDB DEFAULT CHARSET=utf8;';
			
			//echo "<p>".$query."</p>";
			
			if (!mysql_query($query)) err("Error when creating conference registrations table. SQL Query Error: ".mysql_error(), "Database Query Error");
			
			// Set conference status to locked
			$result=mysql_query("UPDATE conferences SET locked = '1' WHERE confname = '" . $confname . "';");
			if (!$result) err("Error when trying to lock newly created conference registrations table. SQL Query Error: ".mysql_error(), "Database Query Error");
		}
		
		// Function for unlocking a conference
		function unlockConf($confname){
			$result=mysql_query("UPDATE conferences SET locked = '0' WHERE confname = '" . $confname . "';");
			if (!$result) err("SQL Query Error: ".mysql_error(), "Database Query Error");
			
			$result = mysql_query('DROP TABLE IF EXISTS conf_' . $confname);							
		}	
		
		// Call the functions which locks/unlocks the selected conference.
		if((isset($_POST['lockConf'])) && (isset($_POST['Button']))){	
			if($_POST['Button'] == 'Lock conference') {
				lockConf($_POST['lockConf']);
			}
			elseif($_POST['Button'] == 'Unlock conference') {
				unlockConf($_POST['lockConf']);
			}
		}

		function countRows($confname){
			$countRows = mysql_query("SELECT * FROM conf_".$confname."");
			if ($countRows) {
				$rowCount = mysql_num_rows ($countRows);
				if ($rowCount > 0) return false;
				else return true; 
			}else {
				return true;
			}
		}
		
		// Saving new data
		if(isset($_POST['editconferences'])&&isset($_POST['Button'])){	
			if($_POST['Button']=="Update"){
				//Checks that the selected times for conference start, registration start/end are valid time-wise.
				if(checkTimes($_POST['confdate'], $_POST['regstart'], $_POST['regend'])){
					// Saving Conference
					$querystring="INSERT INTO conferenceslog(confname, longname, confdate, locked, regstart, regend, offlineregend, beforetext, aftertext, offlineaftertext, price, user, posttime) SELECT confname,longname,confdate,locked,regstart,regend,offlineregend,beforetext,aftertext,offlineaftertext,price,'".$myusername."',now() FROM conferences WHERE confname=".phpencode($_POST['confname'],64).";";
					$result=mysql_query($querystring);												
					if (!$result) err("SQL Update (1) Error: ".mysql_error(),"Database Logging Error");
		
					$querystring="UPDATE conferences SET ";
					$querystring.="confname=".phpencode($_POST['confname'],256).",";
					$querystring.="longname=".phpencode($_POST['longname'],256).",";
					$querystring.="confdate=".phpencode($_POST['confdate'],32).",";
					$querystring.="regstart=".phpencode($_POST['regstart'],32).",";
					$querystring.="regend=".phpencode($_POST['regend'],32).",";
					$querystring.="offlineregend=".phpencode($_POST['offlineregend'],32).",";
					$querystring.="beforetext=".phpencode($_POST['beforetext'],255).",";
					$querystring.="aftertext=".phpencode($_POST['aftertext'],255).",";
					$querystring.="offlineaftertext=".phpencode($_POST['offlineaftertext'],255).",";
					$querystring.="price=".$_POST['price']." ";
					$querystring.=" WHERE confname=".phpencode($_POST['confname'],64).";";
							
					$result=mysql_query($querystring);
					if (!$result) err("SQL Update (2) Error: ".mysql_error(),"Database Update Error");
				}else{
					echo "<span style='font-size: 24px;'>Invalid times set, save unsuccessful.</span>";
				}						
			} else if(($_POST['Button']=="Add Conference") || ($_POST['Button']=="Save as new")){
				//Checks that the selected times for conference start, registration start/end are valid time-wise.
				if(checkTimes($_POST['confdate'], $_POST['regstart'], $_POST['regend'])){
					$clean_confname=trim(preg_replace('/[^a-z0-9]/i', '', $_POST['confnamet'])); //Trims the conferencename from whitespaces and special characters.
					$result=mysql_query("SELECT * FROM conferences WHERE confname='".$clean_confname."';");
					if (!$result) err("SQL Query Error: ".mysql_error(),"Database Query Error for: ".$result);
					if($row = mysql_fetch_assoc($result)) {
						$conferenceexists = true;			
					} else {
						$querystring="INSERT INTO conferences(confname,longname,regstart,regend,offlineregend,beforetext,aftertext,offlineaftertext,confdate,price,locked) VALUES(";
						$querystring.=phpencode($clean_confname,64).",";
						$querystring.=phpencode($_POST['longname'],256).",";
						$querystring.=phpencode($_POST['regstart'],32).",";
						$querystring.=phpencode($_POST['regend'],32).",";
						$querystring.=phpencode($_POST['offlineregend'],32).",";
						$querystring.=phpencode($_POST['beforetext'],256).",";
						$querystring.=phpencode($_POST['aftertext'],256).",";
						$querystring.=phpencode($_POST['offlineaftertext'],256).",";
						$querystring.=phpencode($_POST['confdate'],32).",";
						$querystring.=$_POST['price'].", 0);";
						$result=mysql_query($querystring);
						if (!$result) err("SQL Update (3) Error: ".mysql_error(),"Database Update Error: ".$querystring);	
						
						$querystring="INSERT INTO conferenceslog(price,confname,longname,confdate,regstart,regend,offlineregend,beforetext,aftertext,offlineaftertext,locked, user, posttime) VALUES(";
						$querystring.=$_POST['price'].",";
						$querystring.=phpencode($clean_confname,64).",";
						$querystring.=phpencode($_POST['longname'],256).",";
						$querystring.=phpencode($_POST['confdate'],32).",";
						$querystring.=phpencode($_POST['regstart'],40).",";
						$querystring.=phpencode($_POST['regend'],40).",";
						$querystring.=phpencode($_POST['offlineregend'],40).",";
						$querystring.=phpencode($_POST['beforetext'],100).",";
						$querystring.=phpencode($_POST['aftertext'],100).",";
						$querystring.=phpencode($_POST['offlineaftertext'],100).",";
						$querystring.=phpencode('0',32).",";
						$querystring.="'".$myusername."',now());";
						$result=mysql_query($querystring);
						if (!$result) err("SQL Update (4) Error: ".mysql_error(),"Database Logging Error: ".$querystring);
						//Fetching the newly created user's PID and overwrites the old PID sent with the post.
						$query="SELECT confname FROM conferences WHERE confname='".sanitizeInput($_POST['confnamet'])."'";
						$row = mysql_fetch_array(mysql_query($query));
						$_POST['confname']=$row[0];
						
						//If the user creating the conference is an organizer give the user access to the conference
						if($_SESSION["userkind"] == 2){
							//Get the list of conferences the user has access to
							$persQuery = "SELECT conferences FROM personal WHERE PID='".$_SESSION["userId"]."';";
							$persResult = mysql_query($persQuery);
							if(!$persResult) err("Error when trying to fetch user conferences list SQL Query Error: ".mysql_error(),"Error");
							if(mysql_num_rows($persResult) > 0){
								$persRow = mysql_fetch_array($persResult);
								if($persRow['conferences'] == "") {
									$persRow['conferences'] = $clean_confname; //List is empty
								} else {
									$persRow['conferences'] .= ",".$clean_confname; //List has conferences so we have to add a , before the new conference
								}
								//Update personal table with new information
								$persQuery = "UPDATE personal SET conferences='".$persRow['conferences']."' WHERE PID='".$_SESSION["userId"]."';";
								$persResult = mysql_query($persQuery);
								if(!$persResult) err("Error when trying to update user conferences list SQL Update (5) Error: ".mysql_error(),"Error");
							} else {
								err("User not found","Error");
							}							
						}
					}
				}else{
					echo "<span style='font-size: 24px;'>Invalid times set, save unsuccessful.</span>";
				}
			}		
		}
		/**
		 * Confirmation windows which prevents users to lock/unlock a conference by accident.
		 *
		 * Gathers data about conference and prints it with tables.
		 * passon() functions are used for the site navigation.
		 * If the user choose to lock/unlock the conference, that function is called.
		 */
		if ((isset($_POST['lockConfirm'])) && (isset($_POST['Button']))) {		
			echo "<form action='index.php' method='post'>";
			echo "<input type='hidden' name='lockConf' value='".$_POST['confId']."' />";			
			
			$querystring="SELECT * FROM conferences WHERE confname ='".sanitizeInput($_POST['confId'])."'";		
			$result=mysql_query($querystring);
			if (!$result) err("SQL Query Error: ".mysql_error(),"Conference filter database querying error");
			passon("confname",	"");
			passon("sortorder",	$sortorder);
			passon("sortkind",	$sortkind);
			passon("tabname",	$tabname);
			while ($row = mysql_fetch_assoc($result)) {
				if($_POST['Button'] == "Lock") {
					echo "<h1>Are you sure you want to lock this conference?</h1>";
				} else {
					echo "<h1>Are you sure you want to unlock this conference?</h1>";
				}
				echo "<table>";
				echo "<tr><td>Conference name</td><td>".$row['confname']."</td></tr>";
				echo "<tr><td>Longname</td><td>".$row['longname']."</td></tr>";
				echo "<tr><td>Conference date</td><td>".$row['confdate']."</td></tr>";
				echo "<tr><td>Registration starts</td><td>".$row['regstart']."</td></tr>";
				echo "<tr><td>Online registration ends</td><td>".$row['regend']."</td></tr>";
				echo "<tr><td>Registration ends</td><td>".$row['offlineregend']."</td></tr>";
				echo "<tr><td>Before text</td><td>".$row['beforetext']."</td></tr>";
				echo "<tr><td>After text</td><td>".$row['aftertext']."</td></tr>";
				echo "<tr><td>After Online text</td><td>".$row['offlineaftertext']."</td></tr>";
				echo "<tr><td>Defult price</td><td>".$row['price']."</td></tr>";
				echo "</table>";			
			}					
			if($_POST['Button'] == "Lock") {
				echo "<input name='Button' type='submit' value='Lock conference' />";
			} else {
				echo "<input name='Button' type='submit' value='Unlock conference' />";
			}
			echo "<input name='Button' type='submit' value='Back' />";
			echo "</form>";	
		}
		/**
		 * Prints out editbox with appropriate message (Edit / add conference form.)
		 *
		 * If the user has selected to manage a conference or create a new one, a form for that is created.
		 * passon() functions are used for the site navigation.
		 *
		 * On button "Save as new" onMouseDown() checks if the conferencename already exists.
		 * On button "Copy form" onClick() gathers the values from the selected form and updates the current values.
		 */
		else{
			echo "<div id='editBox'>";		
			if(isset($_POST['addconferences'])){
			}else if(isset($_POST['confname'])){
			}
			else{
				echo "Click in the list to edit the conference.";
			}
			echo "<form action='index.php' method='post' id='editconf'>";
			echo "<input type='hidden' name='editconferences' value='longtail' />";
			
			passon("confname",	"");
			passon("sortorder",	$sortorder);
			passon("sortkind",	$sortkind);
			passon("tabname",	$tabname);	
					
			if(isset($_POST['addconferences']) && (isset($_POST['Button']))) {				
				echo "<table class='editBlock'>";
				echo "<tr class='blockHead'>";
				echo "<td>Conference Name</td><td>Long name</td><td>Conference registration price</td><td></td>";
				echo "</tr><tr class='blockFields'>";			
				if ($conferenceexists){
					echo "<td><input type='text' id='confname' name='confnamet' class='textfield' title='Conferencename is taken, pick another conferencename.' /></td>";				
				} else {
					echo "<td><input type='text' id='confname' name='confnamet' class='textfield' title='Type in a short version of the conference name.' /></td>";
				}			
				echo "<td><input type='text' id='longname' name='longname' class='textfield' title='Type the full name of the conference.' /></td>";
				echo "<td><input type='text' name='price' id='price' value='0' class='textfield' title='Select the defult price for the conference.' /></td>";
				echo "<td></td></tr></table>";
				
				echo "<table class='editBlock'>";
				echo "<tr class='blockHead'>";
				echo "<td>Conference Date</td><td>Registration Start</td><td>Online Registration End</td><td>Registration End</td>";
				echo "</tr><tr class='blockFields'>";
				echo "<td><input type='text' id='confdate' name='confdate' class='textfield dateTime' title='Select the date for your conference.' /></td>";
				echo "<td><input type='text' id='regstart' name='regstart' class='textfield dateTime' title='Select the date when the registrations will open.' /></td>";
				echo "<td><input type='text' id='regend' name='regend' class='textfield dateTime' title='Select the date when the online registrations will be closed.' /></td>";
				echo "<td><input type='text' id='offlineregend' name='offlineregend' class='textfield dateTime' title='Select the date when the registrations will be closed.' /></td>";
				echo "</tr></table>";
				
				echo "<table class='editBlock'>";
				echo "<tr class='blockHead'>";
				echo "<td>Before Text</td><td>After Text</td><td>After Online Text</td><td></td>";
				echo "</tr><tr class='blockFields'>";
				echo "<td><textarea type='text' id='beforetext' name='beforetext' class='textarea' title='Type a text to be displayed when users access the registration form before it's opened.'></textarea></td>";
				echo "<td><textarea type='text' id='aftertext' name='aftertext' class='textarea' title='Type a text to be displayed when users access the registration form after it's closed.'></textarea></td>";
				echo "<td><textarea type='text' id='offlineaftertext' name='offlineaftertext' class='textarea' title='Type a text to be displayed when users access the registration form after the online registration is closed.'></textarea></td>";
				echo "<td>&nbsp;</td>";
				echo "</tr></table>";
			
				echo "<input type='hidden' name='addconferences' value='longtail' />";
				echo "<input name='Button' type='submit' value='Save as new' />&nbsp;&nbsp;";
				
				echo "<select name='copysource' size='1'>";		
				$querystring="SELECT * FROM conferences ORDER BY confdate DESC";			
				$innerresult=mysql_query($querystring);
				if (!$innerresult) err("SQL Query Error: ".mysql_error(),"Conference filter database querying error");
				while ($innerrow = mysql_fetch_assoc($innerresult)) {
					echo "<option value='".$innerrow['confname']."'>".$innerrow['confname']."</option>";
				}				
				echo "<option value='Default'>Default</option>";
				echo "</select>&nbsp;&nbsp;";
				echo "<input name='Button' type='button' value='Copy Form' onClick='copyForm(copysource.value);' />";
				
			}
			/**
			 * Prints out an editing form for the selected conference.
			 *
			 * If the conference has been locked, the fields and buttons are disabled.
			 * passon() functions are used for the site navigation.
			 *
			 * On button "Save as new" onMouseDown() checks if the conferencename already exists.
			 * On button "Copy form" onClick() gathers the values from the selected form and updates the current values.
			 */
			else if(isset($_POST['confname'])){
	
				$querystring="SELECT * FROM conferences WHERE confname='".sanitizeInput($_POST['confname'])."';";		
				$result=mysql_query($querystring);
				if (!$result) err("SQL Query Error: ".mysql_error(),"Conference database querying error");
				
				while ($row = mysql_fetch_assoc($result)) {				
					if ($row['locked'] == 1)
						$disableField = "disabled='disabled'";
					else
						$disableField = "";
						
					echo "<table class='editBlock'>";
					echo "<tr class='blockHead'>";
					echo "<td>Conference Name</td><td>Long name</td><td>Conference registration price</td><td></td>";
					echo "</tr><tr class='blockFields'>";
					
					if ($conferenceexists){
						echo "<td><input type='text' name='confnamet' id='confname' value='".$row['confname']."' class='textfield' ".$disableField." title='Conferencename is taken, pick another conferencename.' /></td>";
						echo "<script language='javascript' type='text/javascript'>var showToolTip = true;</script>";
					} else {
						echo "<td><input type='text' name='confnamet' id='confname' value='".$row['confname']."' class='textfield' ".$disableField." title='Type in a short version of the conference name.' /></td>";
					}		
					echo "<td><input type='text' name='longname' id='longname' value='".$row['longname']."' class='textfield' ".$disableField." title='Type the full name of the conference.' /></td>";
					echo "<td><input type='text' value='".$row['price']."' ".$disableField." type='text' name='price' id='price' value='0' class='textfield' title='Select the defult price for the conference.' /></td>";
					echo "</tr></table>";
					
					echo "<table class='editBlock'>";
					echo "<tr class='blockHead'>";
					echo "<td>Conference Date</td><td>Registration Start</td><td>Online Registration End</td><td>Registration End</td>";
					echo "</tr><tr class='blockFields'>";
					echo "<td><input type='text' name='confdate' id='confdate' value='".$row['confdate']."' class='textfield dateTime' ".$disableField." title='Select the date for your conference.' /></td>";
					echo "<td><input type='text' name='regstart' id='regstart' value='".$row['regstart']."' class='textfield dateTime' ".$disableField." title='Select the date when the registrations will open.' /></td>";
					echo "<td><input type='text' name='regend' id='regend' value='".$row['regend']."' class='textfield dateTime' ".$disableField." title='Select the date when the registrations will be closed. /'></td>";
					echo "<td><input type='text' name='offlineregend' id='offlineregend' value='".$row['offlineregend']."' class='textfield dateTime' ".$disableField." title='Select the date when the registrations will be closed. /'></td>";
					echo "</tr></table>";
					
					echo "<table class='editBlock'>";
					echo "<tr class='blockHead'>";
					echo "<td>Before Text</td><td>After Text</td><td>After Online Text</td><td></td>";
					echo "</tr><tr class='blockFields'>";
					echo "<td><textarea type='text' name='beforetext' 	id='beforetext' class='textarea' ".$disableField." title='Type a text to be displayed when users access the registration form before it's opened.' >".$row['beforetext']."</textarea></td>";			
					echo "<td><textarea type='text' name='aftertext' 	id='aftertext' 	class='textarea' ".$disableField." title='Type a text to be displayed when users access the registration form after it's closed.'  >".$row['aftertext']."</textarea></td>";
					echo "<td><textarea type='text' name='offlineaftertext' 	id='offlineaftertext' 	class='textarea' ".$disableField." title='Type a text to be displayed when users access the registration form after the online registration is closed.'  >".$row['offlineaftertext']."</textarea></td>";
					echo "<td></td>";
					echo "</tr></table>";
					
					echo "<input name='Button' type='submit' value='Update' ".$disableField." />&nbsp;&nbsp;";
					echo "<input name='Button' type='submit' value='Save as new' onMousedown='checkAvailability(confnamet.value);' ".$disableField." />&nbsp;&nbsp;";
					
					echo "<select name='copysource' size='1'" .$disableField.">";
					$querystring="SELECT * FROM conferences ORDER BY confdate DESC";			
					$innerresult=mysql_query($querystring);
					if (!$innerresult) err("SQL Query Error: ".mysql_error(),"Conference filter database querying error");
					while ($innerrow = mysql_fetch_assoc($innerresult)) {
						echo "<option value='".$innerrow['confname']."'>".$innerrow['confname']."</option>";
					}				
					echo "<option value='Default'>Default</option>";
					echo "</select>&nbsp;&nbsp;";
					echo "<input name='Button' type='button' value='Copy Form' onClick='copyForm(copysource.value);' ".$disableField." />";
					
					//Thickbox remove user confirmation
					echo "<div id='removeConfirmBox'>
						<p class='removeConfirm'><strong>Are you sure you want to remove this conference?</strong></p>
							<div class='removeConfirm' style='float: left;'>Conferencename: <br />Longname: <br />Conference date: </div>
							<div class='removeConfirm'>".$row['confname']."<br />".$row['longname']."<br />".$row['confdate']."</div>
							<div class='removeConfirm' id='removeConfirmButtonholder'>
								<input name='Button' type='button' value='Yes' class='button' onClick='removeConf();' />&nbsp;&nbsp;
								<input name='Button' type='button' value='Cancel' class='button' onClick='tb_remove();' />
							</div>
					</div>";					
					echo "</form>";
					echo "<form action='index.php' method='post'><br />";
					echo "<input type='hidden' name='lockConfirm' value='longtail' />";
					echo "<input type='hidden' name='confId' value='".$row['confname']."' />";
					passon("confname","");
					passon("sortorder",$sortorder);
					passon("sortkind",$sortkind);
					passon("tabname",$tabname);

					if(($row['locked']==1) && (countRows($row['confname']) == false)) echo "&nbsp;";
					else if($row['locked']==0) echo "<input name='Button' type='submit' value='Lock' />";
					else echo "<input name='Button' type='submit' value='Unlock' />";										
					if(($row['locked'] == 0) && ($userkind==ADMIN)) {
						echo "&nbsp;&nbsp;<input alt='#TB_inline?height=150&width=295&inlineId=removeConfirmBox' title='Remove user confirmation' class='thickbox' type='button' value='Remove' id='removeButton' />";
					}
				}
			}	
			echo "</form>";				
			echo "</div>";
			
			/** If the user is adding/editing a conference, this saves the values the user is working with.
			 *  This prevents the user from loosing data if the conferencename already exists.
			 */
			if($conferenceexists){
				echo "<script language=javascript type='text/javascript'>setConferenceValues(
					'".$clean_confname."', 
					'".$_POST['longname']."', 
					'".$_POST['regstart']."', 
					'".$_POST['regend']."',
					'".$_POST['offlineregend']."',
					'".$_POST['beforetext']."', 
					'".$_POST['aftertext']."', 
					'".$_POST['offlineaftertext']."', 
					'".$_POST['confdate']."');
				</script>";
			}
			/**
			 * Prints all existing conferences
			 *
			 * The first row of the table consists of a sortoder which allows the user to sort the resaults.
			 * Prints all conferences with an appropriate lock/unlock button.
			 * If there are posts in the conference no button is displayed.
			 *
			 * passon() functions are used for the site navigation.
			 * generatesorter() functions are used for the sortinglist.
			 */	
			if(isset($_POST['sortorder'])) $sortorder=$_POST['sortorder'];
			else $sortorder="None";
			if(isset($_POST['sortkind'])) $sortkind=$_POST['sortkind'];
			else $sortkind="UP";
			
			echo "<h2>Conferences:</h2>";
	
			$querystring="SELECT * FROM conferences";
			$querystring=addsortorder($querystring,$sortorder,$sortkind);
			
			$result=mysql_query($querystring);
			if (!$result) err("SQL Query Error: ".mysql_error(),"Conference Database Querying Error");
			
			$currentrow=0;
			echo "<table id='contentTable' cellspacing='0'>";
			echo "<tr id='top'>";
			generatesorter($sortorder,$sortkind,"confname",		sorterstyle,sorterstyleselected);
			generatesorter($sortorder,$sortkind,"longname",		sorterstyle,sorterstyleselected);
			generatesorter($sortorder,$sortkind,"confdate",		sorterstyle,sorterstyleselected);	
			generatesorter($sortorder,$sortkind,"regstart",		sorterstyle,sorterstyleselected);
			generatesorter($sortorder,$sortkind,"regend",		sorterstyle,sorterstyleselected);
			generatesorter($sortorder,$sortkind,"offlineregend",		sorterstyle,sorterstyleselected);
			generatesorter($sortorder,$sortkind,"beforetext",	sorterstyle,sorterstyleselected);
			generatesorter($sortorder,$sortkind,"aftertext",	sorterstyle,sorterstyleselected);
			generatesorter($sortorder,$sortkind,"offlineaftertext",	sorterstyle,sorterstyleselected);
			generatesorter($sortorder,$sortkind,"price",		sorterstyle,sorterstyleselected);
			generatesorter($sortorder,$sortkind,"locked",		sorterstyle,sorterstyleselected);
			echo "</tr>";
			while ($rowz = mysql_fetch_assoc($result)) {
				// If there are posts in the conferencetable, the lock/unlock button is not displayed in the conferencelist.					
				echo "<a><tr";
				
				if(isset($_POST['confname'])){
					if($_POST['confname'] == $rowz['confname']){
						echo " id='selectedRow'>";
					}else{
						if($currentrow%2==0){ 
							echo " >";
						}else{ 
							echo " class='even' >";
						}						
					}
				}else{
					if($currentrow%2==0){ 
						echo " >";
					}else{ 
						echo " class='even' >";
					}
				}
				
				echo "<form action='index.php' method='post' name='C".$rowz['confname']."'>";
				echo "<input type='hidden' name='confname' value='".$rowz['confname']."' />";
				passon("tabname",$tabname);				
				passon("sortorder",$sortorder);
				passon("sortkind",$sortkind);
				echo "</form>";		
				
				echo "<td onclick='document.C".$rowz['confname'].".submit();'>".$rowz['confname']."</td>";
				echo "<td onclick='document.C".$rowz['confname'].".submit();'>".$rowz['longname']."</td>";
				echo "<td onclick='document.C".$rowz['confname'].".submit();'>".$rowz['confdate']."</td>";
				echo "<td onclick='document.C".$rowz['confname'].".submit();'>".$rowz['regstart']."</td>";
				echo "<td onclick='document.C".$rowz['confname'].".submit();'>".$rowz['regend']."</td>";
				echo "<td onclick='document.C".$rowz['confname'].".submit();'>".$rowz['offlineregend']."</td>";
				echo "<td onclick='document.C".$rowz['confname'].".submit();'>".$rowz['beforetext']."</td>";
				echo "<td onclick='document.C".$rowz['confname'].".submit();'>".$rowz['aftertext']."</td>";
				echo "<td onclick='document.C".$rowz['confname'].".submit();'>".$rowz['offlineaftertext']."</td>";
				echo "<td onclick='document.C".$rowz['confname'].".submit();'>".$rowz['price']."</td>";
				echo "<form action='index.php' method='post'>";
				echo "<input type='hidden' name='lockConfirm' value='longtail' />";
				echo "<input type='hidden' name='confId' value='".$rowz['confname']."' />";
				passon("confname","");
				passon("sortorder",$sortorder);
				passon("sortkind",$sortkind);
				passon("tabname",$tabname);

				if(($rowz['locked']==1) && (countRows($rowz['confname']) == false)) echo "<td>&nbsp;</td>";
				else if($rowz['locked']==0) echo "<td><input name='Button' type='submit' value='Lock' /></td>";
				else echo "<td><input name='Button' type='submit' value='Unlock' /></td>";

				echo "</form>";
				echo "</tr></a>";
				$currentrow++;		
			}
			echo "</table>";
	
			generatesortform("confname",	$sortkind,"index.php");			
			generatesortform("longname",	$sortkind,"index.php");			
			generatesortform("confdate",	$sortkind,"index.php");			
			generatesortform("locked",		$sortkind,"index.php");								
			generatesortform("regstart",	$sortkind,"index.php");								
			generatesortform("regend",		$sortkind,"index.php");	
			generatesortform("offlineregend",		$sortkind,"index.php");								
			generatesortform("beforetext",	$sortkind,"index.php");								
			generatesortform("aftertext",	$sortkind,"index.php");
			generatesortform("offlineaftertext",	$sortkind,"index.php");
			generatesortform("price",	$sortkind,"index.php");								
			
			// Add new conference button
			echo "<br /><form action='index.php' method='post' id='".$rowz['confdate']."'>";
			echo "<input type='hidden' name='addconferences' value='longtail' />";
			passon("confname",	"");
			passon("sortorder",	$sortorder);
			passon("sortkind",	$sortkind);
			passon("tabname",	$tabname);
			echo "<input name='Button' type='submit' value='Add new conference' />";
			echo "</form>";
		}	
	}
?>
