<?php

	//---------------------------------------------------------------------------------------------------------------
	// View Registrations Tab
	//---------------------------------------------------------------------------------------------------------------

	// The reason for using includes is that we can maximize reuse
	// View registration either supports a conference filter or a per user filter depending on the user category
	function checkQuery($qry){
		$splitQry = explode(" ", $qry);
		$count = count($splitQry);
		for($i=0;$i<$count;$i++)
		{
			if(badQry($splitQry[$i]))
			{
				return false;
			}
		}
		return true;
	}
	function badQry($badQry){
		switch(strtolower($badQry))
		{
			case "drop" :
				return true;
			case "delete" :
				return true;
			case "select" :
				return true;
			case "update" :
				return true;
		}
	}
	function badTable($badTable){
		$cTable = strtolower(trim($badTable));
		if(!($cTable=="personal"||$cTable=="cards"||$cTable=="cardlayout"||$cTable=="conferences"||$cTable=="fields"))
		{
			return true;
		}
	}
	function checkTable($qry){
		$splitQry = explode("insert into ", strtolower($qry));
		$count = count($splitQry);
		for($i=1;$i<$count;$i++){
			if(badTable(substr($splitQry[$i], 0, strpos($splitQry[$i], "("))))
			{
				return false;
			}
		}
		return true;
	}
	
	if($tabname=="ViewLogs" && $userkind==ADMIN){
		$errVal = "";
		$errMsg = "";
		if(isset($_POST["query"])){
			//Bara insert
			//Bara logs tabellerna
			/*Drop
			Select
			Delete
			Update*/
			$query = $_POST['query'];
			if(checkQuery($query)){
				if(checkTable($query)){
					$mysqli = new mysqli(DB_HOST, DB_USER, DB_PASSWORD, DB_NAME);
					if (mysqli_connect_errno()) {
						printf("Connect failed: %s\n", mysqli_connect_error());
						exit();
					}
					if ($mysqli->multi_query($query)) {
						//Klart
						$errMsg = "<span style=\"color: green;font-size: 18px;\">Success - The data has been saved.</span>";
					}else{
						//FEL
						$errMsg = "<span style=\"color: red;font-size: 18px;\">Error - Check your sql query.</span>";
						$errVal = $query;
					}
					$mysqli->close();
				}else{
					$errMsg = "<span style=\"color: red;font-size: 18px;\">Error - Bad query. Insert statements is only allowed in tables personal, cards, cardlayout, conferences and fields.</span>";
					$errVal = $query;
				}
			}else{
				$errMsg = "<span style=\"color: red;font-size: 18px;\">Error - Bad query. Only insert statements are allowed.</span>";
				$errVal = $query;
			}
		}
		echo "<h2>SQL Query</h2>";
		echo "<form name=\"queryFrame\" action=\"index.php\" method=\"post\">";
		passon("tabname",$tabname);
		//passon("cardfilter",$cardfilter);
		echo "<textarea style=\"width:100%;height:200px;\" name=\"query\">$errVal</textarea>";
		echo "<br />";
		echo "<input type=\"submit\" value=\"Run Query\" />";
		echo " ".$errMsg;
		echo "</form>";
		
		echo "<h2>Logs</h2>";
		$querystring="SHOW TABLES;";		
		$result=mysql_query($querystring);
		if (!$result) err("SQL Query Error: ".mysql_error(),"Conference database querying error");
		
		echo "<br /><pre>\n";
		// Encode av media estetik och berattande
		while ($row = mysql_fetch_assoc($result)) {
			foreach ($row as $key => $value){
				$querystring="SELECT * FROM ".$value.";";		
				$innerresult=mysql_query($querystring);
				if (!$innerresult) err("SQL Query Error: ".mysql_error(),"Conference database querying error");
	
				while ($innerrow = mysql_fetch_assoc($innerresult)) {
					echo "INSERT INTO ".$value." (";
					$cnt=0;
					foreach ($innerrow as $innerkey => $innervalue){
						if($innervalue!=""){
							if ($cnt>0) echo ",";
							echo $innerkey;
							$cnt++;
						}
					}
					echo ") VALUES (";
					$cnt=0;
					foreach ($innerrow as $innerkey => $innervalue){
						if($innervalue!=""){
							if ($cnt>0) echo ",";
							echo "\"".$innervalue."\"";
							$cnt++;
						}
					}								
					echo ");\n";
				}		
			}
		}
		echo "</pre>&nbsp;";
	}
?>
