<?php
	//---------------------------------------------------------------------------------------------------------------
	// View Registrations Tab
	//---------------------------------------------------------------------------------------------------------------

	// The reason for using includes is that we can maximize reuse
	// View registration either supports a conference filter or a per user filter depending on the user category
	
	if($tabname=="ViewRegistrations" && ($userkind==ADMIN || $userkind==ORGANIZER || $userkind==CLIENT)){		
		if(isset($_POST["conferencefilter"])){
			$conferencefilter = $_POST["conferencefilter"];
		}else{
			$conferencefilter = "None";				
		}
		
		$userHasConferences=FALSE;
		$hasLockedConferences=FALSE;	
		//Check if the user has any conferences and if any of those conferences is locked
		if($userConfArray = gatherConferences($_SESSION["userId"])){
			$userHasConferences=TRUE;	
			
			$querystring="SELECT * FROM conferences WHERE locked='1' AND ("; //shows only locked conferences 	
			foreach($userConfArray as $confName){
				$querystring.=" confname='".$confName."' OR";
			}
			$querystring = substr($querystring,0,strlen($querystring)-2); //remove last OR from querystring
			$querystring .= " ) ORDER BY confdate DESC"; //Order by conference date

			$result=mysql_query($querystring);
			if(!$result) err("Error getting data when creating conferences longname array.");
			
			if(mysql_num_rows($result)>0){
				$hasLockedConferences=TRUE;
			}
		}
		
		if($userHasConferences and $hasLockedConferences){
			while ($row = mysql_fetch_assoc($result)) {
				$lockedConferences[]=$row['confname'];
			}
			//Make sure that conferencefilter is set to a conference in the list
			if(!in_array($conferencefilter, $lockedConferences)){
				$conferencefilter = $lockedConferences[0];
			} 
			//Do the same query again to use when creating options in conference filter select
			//This is quite redundant but will work for now as a quick fix
			$result=mysql_query($querystring);
			if(!$result) err("SQL error");
			echo "<form name='conferencefilterform' action='index.php' method='post'>Conference Filter:&nbsp;&nbsp;";
			passon("tabname",$tabname);
			echo "<select name='conferencefilter' size=1 onChange='document.conferencefilterform.submit();'>";
			
			if (!$result) err("SQL Query Error: ".mysql_error(),"Conference filter database querying error");
			while ($row = mysql_fetch_assoc($result)) {
				if($row['confname']==$conferencefilter){
					echo "<option selected='selected' value='".$row['confname']."'>".$row['longname']."</option>";
				}else{
					echo "<option value='".$row['confname']."'>".$row['longname']."</option>";
				}			
			}				
			echo "</select>";
			echo "</form><br />";

			if(isset($_POST['sortorder'])) $sortorder=$_POST['sortorder'];
			else $sortorder="None";
			if(isset($_POST['sortkind'])) $sortkind=$_POST['sortkind'];
			else $sortkind="UP";
			
			$sortkund="UP";				

			if($conferencefilter!="None") {
				/* Check if there is a reminder card, only needs to be checked once. */
				$result = mysql_query("SELECT formname FROM cards WHERE cardname='Reminder' AND formname='$conferencefilter'");
				if (!$result) err("SQL Query Error: ".mysql_error(),"Database Query Error");
				if(mysql_num_rows($result) > 0) {
					$reminderCard = true;
					echo "<div style='display: none' id='remindedSentBox'>";
					echo "<p class='removeConfirm' id='sentBoxP'>text</p>";
					echo "<div class='removeConfirm' id='removeConfirmButtonholder'>";
					echo "<input name='Button' type='button' value='OK' class='button' onclick='tb_remove();' />";
					echo "</div>";
					echo "</div>";
					
				}
				else {
					$reminderCard = false;
					echo "<div class='note'><p>No reminders can be sent. There's no reminder card for this conference.</p></div>";
				}
				

				$filterValue = "";
				if(isset($_POST['filterReg']) && !empty($_POST['filterReg'])) { // The searched terms
					$filterValue = htmlentities($_POST['filterReg'], ENT_QUOTES, 'UTF-8');
					$keywords = $_POST['filterReg'];
				}
				if(isset($_POST['filterColumn']) && !empty($_POST['filterColumn'])) { // The filter button after the search
					if(isset($_POST['selected']) && !empty($_POST['selected']) && $_POST['selected'] == $_POST['filterColumn']) {
						$filterColumn = NULL; // If it's the same button disable it
					}
					else {
						$filterColumn = $_POST['filterColumn'];
					}
				}
				if(isset($_POST['suspiciousState']))
					$suspState = $_POST['suspiciousState'];
				else
					$suspState = 0;
				
				/* All the passing of variables allows for sorting/filtering/search with all settings intact */
				echo "<form method='post' action='index.php'>";
				passon("tabname", $tabname);
				passon("conferencefilter", $conferencefilter);
				passon("sortorder", $sortorder);				
				passon("sortkind", $sortkind);
				echo "<input class='hiddenCheckString' type='hidden' name='checkString' value='' />";
				echo "<input class='hiddenSuspiciousState' type='hidden' name='suspiciousState' value='' />";
				echo "<input name='filterReg' style='width: 200px;' class='textfield' title='Search in the list, use \"quotes\" for isolated words.' id='filterReg' type='text' value=\"$filterValue\" />&nbsp;"; // Show the search term
				echo "<input type='submit' value='Filter' />";
				echo "</form><br/></br>";
				
				if(isset($keywords)) {
					echo "<span style='font-size: 1.9em;'>Results for $filterValue</span>";	
				}
				else {
					echo "<span style='font-size: 1.9em;'>View Registrations</span>";
				}
				echo "<br/><input id='suspStateCbox' onclick='suspState(true);' type='checkbox' name='suspiciousState'";
				if($suspState == 1) {
					echo "checked";
				}
				echo "/><label id='suspStateString' for='suspStateCbox'type'>Show suspicious registrations</label>";

				$querystring = "SELECT ";
				$result = mysql_query("SHOW COLUMNS FROM conf_".$conferencefilter.""); //Gets all columns
				if (!$result) err("SQL Query Error: ".mysql_error(),"Database Query Error");
				
				if(isset($_POST['checkString'])) //Check if set, to reduce errors
					$checkBoxValues = explode(",", $_POST['checkString']); //Gets the column filtering string
				$fieldsExist = false;
				$counter = 0;
				$filteredColumns = array();
				while($row = mysql_fetch_array($result)) {
					if(isset($_POST['checkString'])) { //Check if set, to reduce errors
						if($checkBoxValues[$counter] == '1'  || $row[0] == 'lineno' || $row[0] == 'state' || $row[0] == 'additionalCost') { //If the checkbox was checked
							$querystring .= $row[0].", "; //Adds the column name to the SQL query
							$fieldsExist = true;
							if(!($row[1] == "varchar(3)" || $row[1] == "int(11)")) //Gathers all searchable columns
								$filteredColumns[] = $row[0];
						}
					}
					$counter++;
					if(!($row[1] == "varchar(3)" || $row[1] == "int(11)")) //Gathers all searchable columns
						$allColumns[] = $row[0];
				}
				$querystring = substr($querystring, 0, strlen($querystring)-2);
				if($fieldsExist) { //If there is filtering
					$querystring .= " FROM conf_".$conferencefilter;
					if(isset($filterColumn)) //If a filter column button has been pressed
						$querystring .= searchOneColumn($conferencefilter, $keywords, true, $filterColumn, $suspState);
					else if(isset($keywords)) // If a search has been performed
						$querystring .= genSearchStr($conferencefilter, $keywords, true, $suspState);
				}	
				else {
					$querystring = "SELECT * FROM conf_".$conferencefilter; //No Column filtering hence get all
					if(isset($filterColumn))
						$querystring = searchOneColumn($conferencefilter, $keywords, false, $filterColumn, $suspState);
					else if(isset($keywords))
						$querystring = genSearchStr($conferencefilter, $keywords, false, $suspState);
				}
				
				if(!(isset($keywords)) && !(isset($filterColumn)) && $suspState != 1) {
						$querystring .= " WHERE state != 5"; 
				}
				
				$querystring = addsortorder($querystring,$sortorder,$sortkind);
				if(isset($keywords)) {
					if(!empty($filteredColumns)) //If no filtering of columns has been done get all columns
						$allColumns = $filteredColumns;
					
					$contains = getContColumns($conferencefilter, $keywords, $allColumns, $filteredColumns);
					if(!empty($contains)) { 
						echo "<br/><br/>Filter: ";
						echo "<form method='post' action=''>";
						passon("tabname", $tabname);
						passon("filterReg", $keywords);
						passon("conferencefilter", $conferencefilter);
						passon("sortorder", $sortorder);
						passon("sortkind", $sortkind);
						echo "<input class='hiddenCheckString' type='hidden' name='checkString' value='' />";
						echo "<input class='hiddenSuspiciousState' type='hidden' name='suspiciousState' value='' />";
						
						$selected = false;
						foreach($contains as $contain) { // Generate buttons to limit search to one columns
							echo "<input type='submit' name='filterColumn' value='$contain' ";
							if(isset($filterColumn) && $filterColumn == $contain) { // The selected column
								echo "id='enabledButton'";
								$selected = $contain;
							}
							echo " />";
						}
						if($selected != false)
							passon('selected', $selected);
					}
				}
				echo "</form>";
				echo "<br /><br />";
				$result = mysql_query($querystring);
				if (!$result) err("SQL Query Error: ".mysql_error(),"Database Query Error");
				
				$states = array('', 'Unpaid',  'Paid by card', 'Paid by invoice', 'Reminder sent', 'Suspicious');
				echo "<table id='contentTable' cellspacing='0'>";
				$currentrow=0;
				while ($row = mysql_fetch_assoc($result)) {
					// Make Headings
					if($currentrow==0){
						echo "<tr id='top'><a href='#'><th>&nbsp;</th></a>";
						$iflds = mysql_num_fields($result) - 1;
						for ($i = 0; $i <= $iflds; $i++){
							if(mysql_field_name($result, $i) != "additionalCost")
								generatesorter($sortorder,$sortkind,mysql_field_name($result, $i),sorterstyle,sorterstyleselected);
						}
						if($userkind==ADMIN || $userkind==ORGANIZER) {
							echo "<a href='#'><th>Invoice Payment</th></a><a href='#'><th>Additional Costs</th></a><a href='#'><th>Suspicious</th></a><a href='#'><th>Reminder</th></a></tr>";
						}
						else {
							echo "<a href='#'><th>Additional Costs</th></a></tr>";
						}
						//
					}
					$lineno = $row['lineno'];
					$state = $row['state'];
					echo "<a href='#' style='cursor: default;'><tr id='tr_$lineno'";
					switch ($state) {
						case UNPAID:
							$colorClass = " class='h35 unpaid' >";
						    break;
						case PAID_BY_CARD:
							$colorClass = " class='h35 paidCard' >";
						    break;
						case PAID_BY_INVOICE:
							$colorClass = " class='h35 paidInvoice' >";
						    break;
						case REMINDER_SENT:
							$colorClass = " class='h35 reminderSent' >";
							break;
						case SUSPICIOUS:
							$colorClass = " class='h35 suspicious' >";
							break;
					}
					echo $colorClass;
					echo "<td>".($currentrow+1)."</td>";
				
					foreach ($row as $key => $field) {
						if($key == "state")
							echo "<td class='h35' id='state_".$lineno."' NOWRAP>".$states[$field]."</td>\n";
						elseif($key == "cost")
							echo "<td class='h35' id='cost_".$lineno."'>".$field."</td>\n";
						elseif($key != "additionalCost")
							echo "<td class='h35'>".$field."</td>\n";
					} 
					if(!isset($keywords))
						$keywords = false;
					if(!isset($filterColumn))
						$filterColumn = false;
					generateButton($userkind, $state, $lineno, "invoice", "", $conferencefilter, $reminderCard);
					generateButton($userkind, $state, $lineno, "addCost", $row['additionalCost'], $conferencefilter, $reminderCard);
					generateButton($userkind, $state, $lineno, 'susp', "", $conferencefilter, $reminderCard);
					generateButton($userkind, $state, $lineno, 'reminder', "", $conferencefilter, $reminderCard);

					echo "</tr></a>";
					generateConfirmBox($userkind, $state, $lineno, $conferencefilter);
					$currentrow++;
				}
				echo "</table>";
				// Generate sorting forms (After printing due to sending of checkbox values)!
				$iflds = mysql_num_fields($result) - 1;
				if(!isset($keywords))
					$keywords = false;
				if(!isset($filterColumn))
					$filterColumn = false;
				for ($i = 0; $i <= $iflds; $i++){
					generatesortformRegistrations(mysql_field_name($result, $i),$sortkind,"index.php", $keywords, $filterColumn);		
				}
				
				if($currentrow == 0)
					echo "There's... nothing here!<br /><br />";
						
				//------------------------------------------------------------------------------------------------
				// Printing
				//------------------------------------------------------------------------------------------------
				echo "<fieldset id='printBox'><legend>Print</legend>";
				
				echo "The list above will be printed. This includes searches, sorting, and chosen columns.<br /><br />";
				echo "<form id='filterForm' name='filterForm' method='post' action='index.php'>";
				passon("tabname", $tabname);
				passon("conferencefilter", $conferencefilter);
				passon("sortorder", $sortorder);
				passon("sortkind", $sortkind);
				passon("filterReg", $keywords);
				passon("filterColumn", $filterColumn);
				echo "<input class='hiddenCheckString' type='hidden' name='checkString' value='' />";	
				echo "<input class='hiddenSuspiciousState' type='hidden' name='suspiciousState' value='' />";
				echo "<table border='0' cellspacing='0'>";
				echo "<input onclick='checkAllBoxes(); checkB();' type='checkbox' name='checkAll' id='checkAll' checked />";
				echo "<label style='font-size:1.4em;' for='checkAll'>ALL</label><br /><br />";
				
				$querystring="SHOW COLUMNS FROM conf_".$conferencefilter;
				$res = mysql_query($querystring);
				if (!$res) err("SQL Query Error: ".mysql_error(),"Database Query Error");
				$counter = 0;
				echo "<tr>";
				while ($row = mysql_fetch_assoc($res)) {
					$name = $row['Field'];
					if($counter%4 == 0) { //Every forth checkbox a new row is created
						echo "</tr><tr>";
					}
					echo "<td style='padding-right: 7px;'>";
					echo "<input onchange='checkB();' id='".$name."' type='checkbox' name='".$name."' value='1' ";
					if(isset($_POST['checkString'])) {
						if($checkBoxValues[$counter] == "1") {
							echo "checked ";
						}
					}
					else {
						echo "checked ";	
					}
					echo " /><label for='".$name."'>".$name."</label>";
					echo "</td>";
					$counter++;
				}
				echo "</tr></table><br />";
				echo "<input type='submit' value='Filter Columns' />";
				echo "<input type='submit' value='Print' onclick='filterForm.action=\"printRegistrations.php\"; return true;' />";
				echo "</form>";
				echo "</fieldset>";								
			}
		} else {
			//Error handling
			if(!$userHasConferences) echo "No confereces registred for this user.";
			else if(!$hasLockedConferences) echo "No locked conferences to view registrations for.";
			else echo "Unknown error when trying to gather conference registration data.";
		}				
	}
?>
